/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: prc_config.h 864 2011-08-08 06:15:04Z mit-kimai $
 */

/*
 *		ץå¸⥸塼SH2A-DUALѡ
 *
 *	Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *	롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *	ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_TARGET_CONFIG_H
#error  target_config.h is not included!
#endif	/*  TOPPERS_TARGET_CONFIG_H  */

/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	4	/* åΥ饤ñ */
#define CHECK_FUNC_ALIGN	2	/* ؿΥ饤ñ */
#define CHECK_FUNC_NONNULL		/* ؿNULLå */
#define CHECK_STACK_ALIGN	4	/* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL		/* åΰNULLå */
#define CHECK_MPF_ALIGN		4	/* ĹסΰΥ饤ñ */
#define CHECK_MPF_NONNULL		/* ĹסΰNULLå */
#define CHECK_MB_ALIGN		4	/* ΰΥ饤ñ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *	ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *	ȥ(start.S)
 */
extern void start(void);

/*
 *	̤ϿγѤΥȥ
 */
extern void default_int_handler_entry(void);

/*
 *	󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *	ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} TSKCTXB;


#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

/*
 *	ƥȥ֥å
 */
typedef struct task_initialization_context_block {
	SIZE	stksz;			/* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
} TSKINICTXB;


/*
 *  ޥץå֤
 */
Inline bool_t
x_sense_mprc(void)
{
	if (x_prc_index() == (TOPPERS_MASTER_PRCID - 1)) {
		return true;
	}
	else {
		return false;
	}
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *	ͥ٥ޥ饤֥
 *	
 *	SH2A-DUALǤϡơ쥸SRˤ47ӥåܤ4ӥåȤ˳
 *	ͥ٥ޥʥϡɥγͥ٥ޥIPMˤ֤Ƥ
 *	롥IPM¸Ƥˡͥ٤γɽ-1Ϣ³
 *	͡ˤȤȤǽǤ뤬;פʺӥåȥեȤȿ
 *	žɬפˤʤ롥򤱤뤿ˡIPM¸ˤϡSR47
 *	ӥåܤФͤȤȤˤ롥ͤͥ٥ޥ
 *	ɽȸƤӡIIPMȽ񤯤Ȥˤ롥
 */

/*
 *	ͥ٥ޥγɽɽѴ
 *
 *	֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)	 (-CAST(PRI,(iipm) >> 4))		/* ɽɽ */
#define INT_IPM(ipm)	 (CAST(uint32_t, -(ipm)) << 4)	/* ɽɽ */

/*
 *	CPUå֤Ǥγͥ٥ޥ
 *
 *	TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *	ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK	 TMIN_INTPRI

/*
 *	ͥγߤ򥵥ݡȤ뤫ݤ̤
 */
#if TIPM_LOCK != -15
#define TOPPERS_SUPPORT_NONKERNEL_INT
#endif

/*
 *	CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK	 INT_IPM(TIPM_LOCK)

/*
 *	ͥ٥ޥTIPM_ENAALLˤɽ
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

/*
 *	ߥåɽ
 */
#define IIPM_DISALL  UINT_C(0xf0)


#ifndef TOPPERS_MACRO_ONLY

/*
 *	IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint32_t
current_iipm(void)
{
	return((uint32_t)(current_sr() & 0xF0U));
}

/*
 *	IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint32_t iipm)
{
	uint32_t sr = current_sr();

	sr = (sr & ~0xF0U) | iipm;
	set_sr(sr);
}

Inline void
set_iipm_with_nop(uint32_t iipm)
{
	uint32_t sr = current_sr();

	sr = (sr & ~0xF0U) | iipm;
	set_sr_with_nop(sr);
}

/*
 *	TOPPERSɸ߽ǥμ¸
 *
 *	SH2A-DUALϥơ쥸(SR)˳ͥ٥ޥ(IPM)äƤ롥
 *	CPUåե饰ǽʤΤᡤŪCPUå
 *	饰¸롥
 *
 *	ޤCPUå֤ѿ(lock_flag)Ѱդ롥
 *
 *	CPUåե饰ꥢƤ֤ϡIPMǥγͥ
 *	ޥͤꤹ롥δ֤ϡǥγͥ٥ޥϡ
 *	IPMѤ롥
 *	
 *	ФCPUåե饰åȤƤ֤ϡIPM򡤥ͥ
 *	ΤΤ٤Ƥγ׵ޥ(TIPM_LOCK)ȡ
 *	γͥ٥ޥȤι⤤ꤹ롥δ֤Υǥγ
 *	ͥ٥ޥϡΤѿ(saved_iipm, ɽݻ)
 *	դݻ롥
 *
 *	ФCPUåե饰åȤƤ֤ϡ
 *	 IPM򡤥ͥΤΤ٤Ƥγ׵ޥ
 *	 (TIPM_LOCK)
 *	 ǥγͥ٥ޥ
 *	ΣĤ⡢⤤ꤹ롥δ֤Υǥγͥ٥ޥ
 *	ϡΤѿ(saved_iipm, ɽݻ)Ѱդݻ롥
 *	ƥȤǤϡCPUåְʳǤϡsaved_iipmϾIPM
 *	Ʊͤˤʤ褦ˤ롥
 */

/*
 *	ץåֻȤκݤȸ
 *	ޥץåǤϡץåֻȤκݤ˥ޥ졼
 *	θơCPUåˤɬפ롣
 *	
 *Ʊѥˤ˸뤿ᡢȸ򥤥饤ؿ
 *	pre_lock()post_lock()ȤơޤȤ᤿
 *	
 *	ˡ
 *	uint32_t iimp = pre_lock():
 *	󥰥ץåν
 *	post_lock();
 *	
 */

/*
 *	ץåֻȤκݤ
 */
Inline uint32_t
pre_lock(void)
{
	uint32_t sr, iipm;
	/*
	 *	ޥ졼θơCPUåˤ롣
	 */
	sr = current_sr();
	iipm = sr & 0xF0U;
#ifndef TOPPERS_SUPPORT_NONKERNEL_INT
						/*  ͥγߤ򥵥ݡȤʤ  */
	set_sr(sr | 0xF0U);		/*  ߶ػ  */
#else /* TOPPERS_SUPPORT_NONKERNEL_INT */
						/*  ͥγߤ򥵥ݡȤ  */
	/*
	 *  ͥ߶ػߤǤʤС
	 *  ͥߤΤߡػߤ롣
	 */
	if (IIPM_LOCK > iipm) {
		set_iipm(IIPM_LOCK);
	}
#endif /* TOPPERS_SUPPORT_NONKERNEL_INT */
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	return(iipm);
}


/*
 *	ץåֻȤκݤθ
 */
Inline void
post_lock(uint32_t iipm)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	set_iipm(iipm);		/*  CPUå֤᤹  */
}


/*
 *	ƥȤλ
 *
 *	SH2A-DUALǤϡƥȤȽ˳/CPU㳰ΥͥȲѤ
 *	
 */
Inline bool_t
sense_context(void)
{
	uint32_t iipm;
	PCB *my_p_pcb;
	bool_t ret;
	
	iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	if ((my_p_pcb->target_pcb.excnest_count) != 0U) {
		ret = true;			/*  󥿥ƥ  */
	} else {
		ret = false;		/*  󥿥ƥ  */
	}
	post_lock(iipm);		/*  CPUå֤᤹  */

	return(ret);
}

/*
 *	CPUå֤ؤΰܹ
 *
 *	IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *	ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *	ꤹ롥ޤlock_flagtrueˤ롥
 *
 *	IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *	saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *	γͥ٥ޥTIPM_LOCKƱ⤤٥
 *	Ƥ֤ˤ롥
 *
 *	δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *	ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	uint32_t iipm;
	PCB *my_p_pcb;

	/*
	 *	pre_lock()֤ͤľsaved_iipm¸ѿiipm
	 *	ѤƤΤϡʲͳˤ롣
	 *	
	 *	󥰥ץåƱͳ
	 *	pre_lock()Ƥľ˳ߤȯư줿߽
	 *	PCBsaved_iipmѹǽ뤿
	 *	ޥץåͭͳ
	 *	pre_lock()Ǥʤȡmy_p_pcb˥Ǥʤ
	 *	pre_lock()ͤ¸Ƥɬפ롣
	 */
	iipm = pre_lock();	/*  ׸ƤŪȰ㤦ˡ  */

	my_p_pcb = get_my_p_pcb();
	my_p_pcb->target_pcb.saved_iipm = iipm;
	my_p_pcb->target_pcb.lock_flag = true;
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
}

#define t_lock_cpu()	x_lock_cpu()
#define i_lock_cpu()	x_lock_cpu()

/*
 *	CPUå֤β
 *
 *	lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *	saved_iipm¸᤹ͤ
 *
 *	δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *	ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	PCB *my_p_pcb;
	uint32_t saved_iipm;

	my_p_pcb = get_my_p_pcb();
	my_p_pcb->target_pcb.lock_flag = false;
	saved_iipm = my_p_pcb->target_pcb.saved_iipm;

	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	set_iipm_with_nop(saved_iipm);
}

#define t_unlock_cpu()	  x_unlock_cpu()
#define i_unlock_cpu()	  x_unlock_cpu()

/*
 *	CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	uint32_t iipm;
	PCB *my_p_pcb;
	bool_t lock_flag;

	iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	lock_flag = my_p_pcb->target_pcb.lock_flag;
	post_lock(iipm);		/*  CPUå֤᤹  */

	return(lock_flag);
}

#define t_sense_lock()	  x_sense_lock()
#define i_sense_lock()	  x_sense_lock()

/*
 *  ƥ  CPUå֤ʤ true
 *  
 *  (!sense_context() && !t_sense_lock())ǤȽǤ뤬
 *  ߶ػߡĤΥСإåɤ򸺤餹ᡢ
 *  ĤˤޤȤƤ롣
 */
Inline bool_t
sense_tskctx_unl(void)
{
	uint32_t iipm;
	PCB *my_p_pcb;
	bool_t ret;

	iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	/*
	 *  CPUå֤û뤿ᡢ
	 *  ifʸΥåCPUå֤γ˰ư뤳Ȥ
	 *  Ƥ󥿥ƥȤξlock_flag
	 *  ɤ߽ФɬפꡢΨᡢΤޤޤȤƤ롣
	 */
	if ((my_p_pcb->target_pcb.excnest_count == 0)	/*  ƥ  */
		&& !(my_p_pcb->target_pcb.lock_flag)) {		/*  CPUå  */
		ret = true;
	} else {
		ret = false;
	}
	post_lock(iipm);		/*  CPUå֤᤹  */

	return(ret);
}

/*
 *  󥿥ƥ  CPUå֤ʤ true
 *  
 *  (sense_context() && !i_sense_lock())ǤȽǤ뤬
 *  ߶ػߡĤΥСإåɤ򸺤餹ᡢ
 *  ĤˤޤȤƤ롣
 */
Inline bool_t
sense_intctx_unl(void)
{
	uint32_t iipm;
	PCB *my_p_pcb;
	bool_t ret;

	iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	/*
	 *  CPUå֤û뤿ᡢ
	 *  ifʸΥåCPUå֤γ˰ư뤳Ȥ
	 *  ƤƥȤξlock_flag
	 *  ɤ߽ФɬפꡢΨᡢΤޤޤȤƤ롣
	 */
	if ((my_p_pcb->target_pcb.excnest_count != 0)	/*  󥿥ƥ  */
		&& !(my_p_pcb->target_pcb.lock_flag)) {		/*  CPUå  */
		ret = true;
	} else {
		ret = false;
	}
	post_lock(iipm);		/*  CPUå֤᤹  */

	return(ret);
}


/*
 *	chg_ipmͭʳͥ٤ϰϤȽ
 *
 *	TMIN_INTPRIͤˤ餺chg_ipmǤϡ-15TIPM_ENAALLʡ0ˤϰ
 *	Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri)) && ((intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *	CPUåե饰ꥢƤϡϡɥγͥ٥
 *	ꤹ롥
 *	
 *	CPUåե饰åȤƤϡϡɥγͥ٥
 *	ꤷ褦ȤʥǥΡ˳ͥ٥ޥTIPM_LOCK
 *	ι⤤ꤹ롥
 *
 */
Inline void
x_set_ipm(PRI intpri)
{
	PCB *my_p_pcb;
	uint32_t saved_iipm;
	uint32_t iipm = INT_IPM(intpri);

	saved_iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	
	if (!(my_p_pcb->target_pcb.lock_flag)) {
		/*  CPUå  */
		set_iipm(iipm);
	}
	else {
		/*
		 *	CPUå֤ʤΤǡͥγߤʤ
		 *	target_pcb.saved_iipmʤ
		 */
		my_p_pcb->target_pcb.saved_iipm = iipm;
#ifndef TOPPERS_SUPPORT_NONKERNEL_INT
						/*  ͥγߤ򥵥ݡȤʤ  */
		/*
		 *	λǥϡɥγͥ٥ޥɬ15
		 *	ꤵƤ뤿ᡤꤷľɬפʤ
		 */
#else /* TOPPERS_SUPPORT_NONKERNEL_INT */
						/*  ͥγߤ򥵥ݡȤ  */
		set_iipm((iipm > IIPM_LOCK) ? iipm : IIPM_LOCK);
#endif /* TOPPERS_SUPPORT_NONKERNEL_INT */
	}
	/* IPM񤭴ǥ꤬񤭴ǽ */
	Asm("":::"memory");
}

#define t_set_ipm(intpri)	 x_set_ipm(intpri)
#define i_set_ipm(intpri)	 x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *	CPUåե饰ꥢƤϥϡɥγͥ٥
 *	򡤥åȤƤPCBsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	PCB *my_p_pcb;
	uint32_t saved_iipm;
	uint32_t iipm;

	saved_iipm = pre_lock();		/*  CPUå  */
	my_p_pcb = get_my_p_pcb();
	if (!(my_p_pcb->target_pcb.lock_flag)) {
		/*  CPUå  */
		iipm = saved_iipm;
	}
	else {
		/*  CPUå  */
		iipm = my_p_pcb->target_pcb.saved_iipm;
	}
	post_lock(saved_iipm);			/*  CPUå֤᤹  */
	return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *	ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *	dispatchϡƥȤƤӽФ줿ӥ
 *	ƤӽФ٤Τǡ
 *	 ƥ
 *	 CPUå
 *	 ǥѥåľ
 *	 ʥǥΡ˳ͥ٥ޥ
 *	ǸƤӽФʤФʤʤ
 */
extern void dispatch(void);

/*
 *  Υޥ졼prc_support.S
 */
extern void dispatch_and_migrate(ID prcid);

/*
 *  ߤΥƥȤΤƥޥ졼prc_support.S
 */
extern void exit_and_migrate(ID prcid);

/*
 *	ǥѥåưϡprc_support.S
 *
 *	start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *	ߤػߤ֡ߥå֤Ʊξ֡ˤǸƤӽФʤ
 *	ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *	ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *	exit_and_dispatchϡext_tskƤӽФ٤Τǡ
 *	 ƥ
 *	 CPUå
 *	 ǥѥåľ
 *	 ʥǥΡ˳ͥ٥ޥ
 *	ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *	ͥνλθƽФprc_support.S
 *
 *	call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *	ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *	
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *	ƥȤν
 *
 *	ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *	ǥåΰȤäƤϤʤʤ
 *
 *	activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *	λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb) 										\
{																		\
	(p_tcb)->tskctxb.sp = (p_tcb)->p_tinib->tskinictxb.stk_bottom;		\
	(p_tcb)->tskctxb.pc = (FP)start_r;									\
}

/*
 *	calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 * ޥˤasp/kernel/exception.hǥץȥ
 * Ƥ뤿ᡢؿȤʤФʤʤ
 */
extern void initialize_exception(void);

/*
 *	SH2A-DUALγߥƥȳ߽ǥμ¸
 */

/*
 *	ͥ
 *
 *	Ƴߤγͥ٤ϳͥ٥쥸(IPRXX)ˤ
 *	ꤹ롥ΤᡤƳ׵饤ˤɤγͥ٥
 *	쥸ΤɤΥեɤбƤ뤫ξIPR_INFOˤ
 *	ơ֥ipr_info_tbl[]Ѱդ롥
 *	ֹϢ³ƤʤᡤݡȤƤʤֹˤϡ
 *	addressȥ0ꤷˤֹȽ̤Ǥ
 *	롣
 *	ʥݡȤֹϥץꥱˤ餺ץå
 *	ϡɥͤˤäƷޤΤǡǡȤݻ롣
 *	Υơ֥ΥǥåˤϡֹɽѤ롣
 */

/*
 *	ƳֹꤹIPRξΤι¤
 *	
 *	ݡȤʤֹξϡaddressȥ0ꤹ롣
 *	
 *	offset8ӥåȤнʬͳ32ӥåȤˤ
 *	롣
 *	ι¤Τˤȷ֤Ǥǡ
 *	ʤʤ
 *	SHǤ32ӥåȥǡǤʤ̵̤̿᤬롣
 */
typedef struct {
	/* ͥ٥쥸Υɥ쥹 */
	uint32_t address;
	/* եå */
	uint32_t  offset;
} IPR_INFO;

/*
 *	ƳֹIPRξơ֥
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INT];

/*
 *	ֹ桦ߥϥɥֹ
 *
 *	ߥϥɥֹ(inhno)ȳֹ(intno)ϡ٥ֹѤ롥
 *
 *	٥ֹTMIN_INTNO(=64)Ϥޤ뤿ᡤΤޤޤͤͥٴ
 *	Υơ֥ΥǥåѤȡ̵̤ΰ褬ȯ롥
 *	ΤᡤͥǤϡTMIN_INTNO򺹤͡ɽ
 *	Ѥ롥
 *
 *	ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 * ߥϥɥֹɽѴ
 */
											/* ɽɽ */
#define EXT_INHNO(iintno) (CAST(uint32_t, (iinhno) + TMIN_INHNO))
											/* ɽɽ */
#define INT_INHNO(intno)  (CAST(uint32_t, (inhno) - TMIN_INHNO))

/*
 * ֹɽѴ
 */
											/* ɽɽ */
#define EXT_INTNO(iintno)	(CAST(uint32_t, (iintno) + TMIN_INTNO))
											/* ɽɽ */
#define INT_INTNO(intno)	(CAST(uint32_t, (intno) - TMIN_INTNO))


/*
 *	ֹϰϤȽ
 *	
 *	TMIN_INTNOTMAX_INTNOϰϤǤäƤֹͭǤʤ礬뤿
 *	ᡤipr_info_tbl[]ֹͭ椫å
 */

/*  ֹ椫ץåIDФޥ  */
#define PRCID_IN_INTNO(intno)	((intno) & ~LOCAL_INTNO_MASK)

/*  դǽץåΥå ׸Ƥץå¸ */
#define VALID_AFFINITY_MASK(intno)							\
		(PRCID_IN_INTNO(intno) <= 0x20000U)					\
		&& (PRCID_IN_INTNO(intno) != 0x0U)
		/*  եȥŪ˥IRCꤷƤ  */

/*  IRQޤ¢ե⥸塼γֹȽ  */
#define VALID_LOCAL_INTNO_IRQ_OR_PERIPHERAL(local_intno)	\
		((TMIN_INTNO <= (local_intno)) 						\
		&& ((local_intno) <= TMAX_INTNO) 					\
		&& (ipr_info_tbl[INT_INTNO(local_intno)].address != 0U))

/*  ץåֳߤγֹȽ  */
#define VALID_LOCAL_INTNO_IPI(local_intno) 					\
		LOCAL_INTNO_IS_IPI(local_intno)

#define VALID_LOCAL_INTNO(local_intno) 					\
		(VALID_LOCAL_INTNO_IRQ_OR_PERIPHERAL(local_intno)	\
		 || VALID_LOCAL_INTNO_IPI(local_intno))

#define VALID_INTNO(intno) 									\
		(VALID_AFFINITY_MASK(intno) && VALID_LOCAL_INTNO(LOCAL_INTNO(intno)))

/*  ׸ƤprcidѤȽԤ  */
#define VALID_INTNO_DISINT(prcid, intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(prcid, intno)	VALID_INTNO(intno)

/*
 *	CPU㳰ϥɥֹ
 *
 *	CPU㳰ϥɥֹȤƤϡ٥ֹѤ롥
 *	ݡȤCPU㳰ϥɥϥץåη˰ۤʤΤǡץ
 *	åηե롥
 *	
 *	TMIN_EXCNOTMAX_EXCNOϰϤǤäƤֹͭǤʤ礬뤬
 *	åάƤ롣
 *
 */
#define VALID_LOCAL_EXCNO_DEFEXC(local_excno) \
		((TMIN_EXCNO <= (local_excno)) && ((local_excno) <= TMAX_EXCNO))
#define VALID_EXCNO_DEFEXC(excno) 	\
		(VALID_AFFINITY_MASK(excno)	\
		&& VALID_LOCAL_EXCNO_DEFEXC(LOCAL_EXCNO(excno)))

/*
 *	ߥϥɥ
 *
 *	ߥϥɥֹinhnoγߥϥɥεưint_entry
 *	ꤹ롥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{
#ifndef NDEBUG
	uint_t prcid_in_inhno = inhno >> 16U;
	uint_t bitptn = 1U << (prcid_in_inhno - 1U);

	assert((bitptn & affinity_mask) != 0);
#endif /* NDEBUG */
}

/*
 *	ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)	 _kernel_##inthdr##_##inhno
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)					\
		extern void _kernel_##inthdr##_##inhno(void);

/*
 *	׵ػߥե饰
 *
 *	SH2A-DUALIRCϳ׵ػߥե饰ʤߤ̤˶ػߤ
 *	ϡͥ٥쥸(IPRXX)0ꤹɬפ롥
 *	ͥ٥쥸0ˤ뤳Ȥǳ׵ػߥե饰
 *	¸ȡδ֡ǥγͥ٤򵭲Ƥΰ褬ɬ
 *	Ȥʤ롥ե졼ǤΤuint8_tΥơ֥
 *	int_iipm_tbl[]Ѱդ롥
 *	ͥ٤ꤵƤ뤫ɤϥӥå7ݻ롣
 *	ʥץꥱ˰¸
 *	
 *	ӥåȳƤͥ٤γɽȤɽȤۤʤΤǡ
 *	դ뤳ȡȿžƤ뤬ӥåȥեȤƤʤ
 *	
 *	ơ֥int_iipm_tbl[][]˳ǼͤΥӥåȳơ
 *	ӥå03IPRXXꤹӥåȥѥ
 *	ʳͥ٥
 *	ӥå7NOT_CFG_INT_BIT
 *	0:CFG_INTǳͥ٤ꤵƤ롣
 *	1:CFG_INTǳͥ٤ꤵƤʤ
 */
extern const uint8_t int_iipm_tbl[TNUM_PRCID][TNUM_INT];

/*	CFG_INTǳͥ٤ꤵƤʤȤ򼨤ӥå  */
#define NOT_CFG_INT_BIT		0x80U

/*
 * ͥ٥쥸
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint32_t valIPR쥸ꤹ
 *	 uint_t prcindexץåǥå0ꥸ
 */
Inline void
irc_set_ipr(INTNO local_intno, uint32_t val, uint_t prcindex)
{
	uint32_t ipr_val;
	uint32_t iintno  	= INT_INTNO(local_intno);
	uint32_t address 	= ipr_info_tbl[iintno].address;
	uint32_t offset  	= ipr_info_tbl[iintno].offset;

   	/*	prcindex=1ξIPRΥɥ쥹˥եå0x100ä  */
   	/*	׸Ƥץå˰¸  */
	if (prcindex != 0) {
		address += PRC_IPR_OFFSET;
	}
	ipr_val = sil_reh_reg((uint16_t *)address);
	ipr_val &= ~(0x0FU << offset);
	ipr_val |= (val << offset);
	sil_wrh_reg((uint16_t *)address, ipr_val);
}

/*
 *	׵ػߥե饰Υå
 *
 *	װ˳߶ػߤˡۤʤ롣
 *
 *	IRQ
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	0ꤹ롥
 *
 *	¢ե⥸塼
 *	IDCNTn쥸INTENӥåȤ򥯥ꥢ롣
 *
 *	PINT
 *	CnPINTER쥸PINTnEӥåȤ򥯥ꥢ롣
 *
 *	ץåֳ
 *	CnIPER쥸CIPEnӥåȤ򥯥ꥢ롣
 *
 *	׸Ƥ
 *	Ūˤϡޥsh2a_dual_config.h˰ư롣
 */

/*
 *	IRQߤζػ
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	0ꤹ롥
 */
Inline void
x_disable_int_irq(INTNO local_intno, uint_t prcindex)
{
	/*
	 *	ֹбIPRͤ0ˤ롥
	 */
	irc_set_ipr(local_intno, 0x00, prcindex);
}

/*
 *	¢ե⥸塼ߤζػ
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	IDCNTn쥸INTENӥåȤ򥯥ꥢ롣
 */
Inline void
x_disable_int_peripheral(INTNO local_intno, uint_t prcindex)
{
	int_t index 		= LOCAL_INTNO_TO_IDCNT(local_intno);
	uint16_t *p_idcnt_h = idcnt_tbl_h[index];
	
	sil_anh_reg(p_idcnt_h, ~IDCNT_INTEN);
}
	
/*
 *	PINTߤζػ
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	CnPINTER쥸PINTnEӥåȤ򥯥ꥢ롣
 */
Inline void
x_disable_int_pint(INTNO local_intno, uint_t prcindex)
{
	uint_t pintno 		 = LOCAL_INTNO_TO_PINTNO(local_intno);
	uint16_t *p_pinter_h = irc_reg_tbl[prcindex].pinter_h;
	
	sil_clrh_bit(p_pinter_h, pintno);
}

/*
 *	ץåֳߤζػ
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	CnIPER쥸CIPEnӥåȤ򥯥ꥢ롣
 */
Inline void
x_disable_int_ip(INTNO local_intno, uint_t prcindex)
{
	uint_t intlevel		= LOCAL_INTNO_TO_IP_INT_LEVEL(local_intno);
	uint16_t *p_iper_h 	= irc_reg_tbl[prcindex].iper_h;
	
	sil_clrh_bit(p_iper_h, intlevel);
}

/*
 *	׵ػߥե饰Υå
 *
 *	°ꤵƤʤ׵饤ФƳ׵ػ
 *	ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 *
 *	װ˳߶ػߤˡۤʤ롣
 *
 *	IRQ
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	0ꤹ롥
 *
 *	¢ե⥸塼
 *	IDCNTn쥸INTENӥåȤ򥯥ꥢ롣
 *
 *	PINT
 *	CnPINTER쥸PINTnEӥåȤ򥯥ꥢ롣
 *
 *	ץåֳ
 *	CnIPER쥸CIPEnӥåȤ򥯥ꥢ롣
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	INTNO iintno;
	uint32_t iipm;
	INTNO local_intno  	= LOCAL_INTNO(intno);
	uint_t prcindex		= x_prc_index();

	/*
	 *	ץåֳߤξ
	 *	ͥ٥뤬ǥơ֥int_iipm_tbl˴ޤޤʤΤǡ
	 *	¾γװ˥å롣
	 */
	if (LOCAL_INTNO_IS_IPI(local_intno)) {
		x_disable_int_ip(local_intno, prcindex);
		return(true);
	}

	iintno = INT_INTNO(local_intno);
	iipm = int_iipm_tbl[prcindex][iintno];

	/*
	 *	°ꤵƤʤ
	 */
	if ((iipm & NOT_CFG_INT_BIT) != 0) {
		return(false);
	}
	
	/*
	 *	Ĥγװ˽򿶤ʬ롣
	 */
	if (LOCAL_INTNO_IS_IRQ(local_intno)) {
		/*	IRQξ  */
		x_disable_int_irq(local_intno, prcindex);
	}
	else if (LOCAL_INTNO_IS_PERIPHERAL(local_intno)) {
		/*	¢ե⥸塼ξ  */
		x_disable_int_peripheral(local_intno, prcindex);
	}
	else if (LOCAL_INTNO_IS_PINT(local_intno)) {
		/*	PINTߤξ  */
		x_disable_int_pint(local_intno, prcindex);
	}
	else {
		return(false);
	}

	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *	׵ػߥե饰β
 *
 *	װ˳ߵĤˡۤʤ롣
 *
 *	IRQ
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	ͤ򸵤᤹
 *
 *	¢ե⥸塼
 *	IDCNTn쥸INTENӥåȤ򥻥åȤ롣
 *
 *	PINT
 *	CnPINTER쥸PINTnEӥåȤ򥻥åȤ롣
 *
 *	ץåֳ
 *	CnIPER쥸CIPEnӥåȤ򥻥åȤ롣
 *
 *	׸Ƥ
 *	Ūˤϡޥsh2a_dual_config.h˰ư롣
 */

/*
 *	IRQߤε
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *	 uint32_t ipr_valIPRx쥸ꤹ
 *
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	ͤ򸵤᤹
 */
Inline void
x_enable_int_irq(INTNO local_intno, uint_t prcindex, uint32_t ipr_val)
{
	/*
	 *	ֹбIPRͤipr_valˤ롥
	 */
	irc_set_ipr(local_intno, ipr_val, prcindex);
}

/*
 *	¢ե⥸塼ߤε
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	IDCNTn쥸INTENӥåȤ򥻥åȤ롣
 */
Inline void
x_enable_int_peripheral(INTNO local_intno, uint_t prcindex)
{
	int_t index 		= LOCAL_INTNO_TO_IDCNT(local_intno);
	uint16_t *p_idcnt_h	= idcnt_tbl_h[index];
	
	sil_orh_reg(p_idcnt_h, IDCNT_INTEN);
}
	
/*
 *	PINTߤε
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	CnPINTER쥸PINTnEӥåȤ򥻥åȤ롣
 */
Inline void
x_enable_int_pint(INTNO local_intno, uint_t prcindex)
{
	uint_t pintno 		 = LOCAL_INTNO_TO_PINTNO(local_intno);
	uint16_t *p_pinter_h = irc_reg_tbl[prcindex].pinter_h;
	
	sil_seth_bit(p_pinter_h, pintno);
}

/*
 *	ץåֳߤε
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 uint_t prcindexץåǥå0ꥸ
 *
 *	CnIPER쥸CIPEnӥåȤ򥻥åȤ롣
 */
Inline void
x_enable_int_ip(INTNO local_intno, uint_t prcindex)
{
	uint_t intlevel		= LOCAL_INTNO_TO_IP_INT_LEVEL(local_intno);
	uint16_t *p_iper_h 	= irc_reg_tbl[prcindex].iper_h;
	
	sil_seth_bit(p_iper_h, intlevel);
}

/*
 *	׵ػߥե饰β
 *
 *	°ꤵƤʤ׵饤ФƳ׵ػ
 *	ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 *
 *	װ˳ߵĤˡۤʤ롣
 *
 *	IRQ
 *	߶ػߥե饰ʤᡢͥ٥쥸(IPRx)
 *	ͤ򸵤᤹
 *
 *	¢ե⥸塼
 *	IDCNTn쥸INTENӥåȤ򥻥åȤ롣
 *
 *	PINT
 *	CnPINTER쥸PINTnEӥåȤ򥻥åȤ롣
 *
 *	ץåֳ
 *	CnIPER쥸CIPEnӥåȤ򥻥åȤ롣
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	INTNO iintno;
	uint32_t iipm;
	INTNO local_intno  	= LOCAL_INTNO(intno);
	uint_t prcindex		= x_prc_index();

	/*
	 *	ץåֳߤξ
	 *	ͥ٥뤬ǥơ֥int_iipm_tbl˴ޤޤʤΤǡ
	 *	¾γװ˥å롣
	 */
	if (LOCAL_INTNO_IS_IPI(local_intno)) {
		x_enable_int_ip(local_intno, prcindex);
		return(true);
	}

	iintno = INT_INTNO(local_intno);
	iipm = int_iipm_tbl[prcindex][iintno];

	/*
	 *	°ꤵƤʤ
	 */
	if ((iipm & NOT_CFG_INT_BIT) != 0) {
		return(false);
	}
	
	/*
	 *	Ĥγװ˽򿶤ʬ롣
	 */
	if (LOCAL_INTNO_IS_IRQ(local_intno)) {
		/*	IRQξ  */
		x_enable_int_irq(local_intno, prcindex, iipm);
	}
	else if (LOCAL_INTNO_IS_PERIPHERAL(local_intno)) {
		/*	¢ե⥸塼ξ  */
		x_enable_int_peripheral(local_intno, prcindex);
	}
	else if (LOCAL_INTNO_IS_PINT(local_intno)) {
		/*	PINTߤξ  */
		x_enable_int_pint(local_intno, prcindex);
	}
	else {
		return(false);
	}

	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *	׵饤°
 *
 *	SH2A-DUALǤϡͥǰͥ٤16ʳǤ뤿ᡤintpri
 *	ȤͿ뤳ȤǤͤ-15-1ɸǤ롥
 *	
 *	SH2A-DUALγߤϡ¢ե⥸塼ߡIRQߤʬǤ
 *	줾찷ۤʤ롥Τᡤֹ椫顤ɤγߤʬह
 *	ΥޥINTNO_IS_IRQ(intno)򥳥¸Ѱդ롥
 *	ϤΥե٤¸Τshx_config.h
 *	x_config_intatr()ǻѤ뤿ᡢshx_config.h˵ҤƤ롣
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);

/*
 *	ߥϥɥνиɬפIRC
 *	ɬפIRCi_begin_int()ϡ¸
 */
Inline void
i_end_int(INTNO intno)
{
}
#endif /* TOPPERS_MACRO_ONLY */

/*
 *	CPU㳰ϥɥط
 */

/*
 *	㳰ϥɥ p_excinf ƼФΥޥ
 */
#define P_EXCINF_OFFSET_VECTOR UINT_C( 0)
#define P_EXCINF_OFFSET_PR	   UINT_C( 1)
#define P_EXCINF_OFFSET_PC	   UINT_C(12)
#define P_EXCINF_OFFSET_SR	   UINT_C(13)

#define P_EXCINF_OFFSET_R0	   UINT_C( 4)

/*	CPU㳰ȯΥåݥ󥿤ͤp_excinfκʬ  */
#define P_EXCINF_OFFSET_SP	   (P_EXCINF_OFFSET_SR + 1)


#ifndef TOPPERS_MACRO_ONLY
/*
 *	CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{
	assert(VALID_EXCNO_DEFEXC(excno));
}

/*
 *	CPU㳰ϥɥޥ
 */
#define EXC_ENTRY(excno, exchdr)	 _kernel_##exchdr##_##excno
#define EXCHDR_ENTRY(excno, excno_num, exchdr)					\
		extern void _kernel_##exchdr##_##excno(void *sp);

/*
 *	CPU㳰ȯΥƥȤλ
 *
 *	CPU㳰ȯΥƥȤƥȤλfalse
 *	Ǥʤtrue֤
 *	CPU㳰ϥɥ餫ƤФ뤳ȤꤷƤΤǡ
 *	ޥ졼󤵤뤳ȤꤷƤʤ
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
	PCB *my_p_pcb = get_my_p_pcb();
	
	return(my_p_pcb->target_pcb.excnest_count > 1U);
}

/*
 *	CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *	ˤλ
 *	CPU㳰ϥɥ餫ƤФ뤳ȤꤷƤΤǡ
 *	ޥ졼󤵤뤳ȤꤷƤʤ
 */
Inline uint32_t
exc_get_iipm(void *p_excinf)
{
	uint32_t *sp = (uint32_t *)p_excinf;
	uint32_t sr = *(sp + P_EXCINF_OFFSET_SR);
	uint32_t iimp = sr & 0x00F0U;
	return(iimp);
}

/*
 *	CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *	CPU㳰ȯΥƥ֤
 *	ͥ¹Ǥʤ
 *	ƥȤǤꡤ
 *	ߥå֤Ǥʤ
 *	CPUå֤Ǥʤ
 *	ʥǥΡ˳ͥ٥ޥ
 *	ǤtrueǤʤfalse֤CPU㳰ͥ
 *	γ߽ȯˤfalse֤ˡ
 *
 *	SH2A-DUALǤϡCPU㳰ȯIPMʥϡɥγͥ٥
 *	ˤ٤ƤγߤĤ֤Ǥ뤳Ȥå뤳Ȥǡ
 *	ͥ¹Ǥʤȡ
 *	ߥå֤Ǥʤȡ
 *	CPUå֤Ǥʤȡ
 *	ʥǥΡ˳ͥ٥ޥ֤Ǥ뤳
 *	4Ĥξå뤳ȤǤCPU㳰ȯ
 *	lock_flag򻲾ȤɬפϤʤˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
					&& (exc_get_iipm(p_excinf) == IIPM_ENAALL));
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 * APIɸŪʤΤȰۤʤ뤿ᡢ桼ѰդΤ
 * ֤ϡץȥ롣
 */
#ifndef OMIT_DEFAULT_INT_HANDLER
extern void default_int_handler(INTNO intno);
#endif /* OMIT_DEFAULT_INT_HANDLER */

/*
 *	ץå¸ν
 */
extern void prc_initialize(void);

/*
 *	ץå¸νλ
 */
extern void prc_exit(void);

/*
 *  åط
 */

/*  åѤ륻ޥե쥸  */
#define SEMR_LOCK	SEMR1_b

/*
 *  㥤ȥåν
 */
Inline void
x_initialize_giant_lock(LOCK *p_giant_lock)
{
		/*
		 *	SEMR == 0 
		 *	SEMR == 1 
		 */
	sil_wrb_reg((uint8_t *)SEMR_LOCK, SEMR_SEMF_BIT);
	*p_giant_lock = (uint8_t *)SEMR_LOCK;
}

/*
 *  Test & Set̿
 *  true 
 *  false
 */
Inline bool_t
test_and_set(uint8_t *p_semr_b)
{
	uint8_t semr = sil_reb_reg(p_semr_b);
	
	if (semr == 0) {
		return true;
	}
	return false;
}

/*
 *  åؿ
 *  x_lock_cpu()/x_unlock_cpu()Ȥᡤ餬줿
 *  롥 
 */

/*
 *  1ܤΥåʥ󥿥ƥȶѡ
 */
Inline void
x_acquire_lock(LOCK *p_lock)
{
	uint8_t *p_semr_b = *p_lock;

	while (test_and_set(p_semr_b)) {
		x_unlock_cpu();
		x_lock_cpu();
	}

	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
}

#define t_acquire_lock(p_lock) x_acquire_lock(p_lock)
#define i_acquire_lock(p_lock) x_acquire_lock(p_lock)


/*
 *  åβʥ󥿥ƥȶѡ
 */
Inline void
x_release_lock(LOCK *p_lock)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	sil_wrb_reg(*p_lock, SEMR_SEMF_BIT);
}

/*
 *  ߤĤʤåؿ
 */
Inline void 
x_acquire_lock_without_preemption(LOCK *p_lock)
{
	uint8_t *p_semr = *p_lock;

	/*  δ֡롼פ򷫤֤  */
	while (test_and_set(p_semr));
	
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
}


/*
 *  ԥåط
 */

/*
 *  ԥåǽ
 */
#define TTYPE_SPN NATIVE_SPN

/*
 *  ͥƥ֥ԥξΥԥåκ
 *  -2ƤΤϡåSILǻѤʬ
 */
#define TMAX_NATIVE_SPN   (32 - 2)

/*
 *  ԥåη
 */
typedef uint8_t *SPNLOCK;

/*
 *  ԥåν
 */
Inline void
x_initialize_spin(ID spnid, SPNLOCK *p_spn_lock)
{
	uint8_t *p_semr_b = semr_tbl_b[spnid + 2];
	
	*p_spn_lock = p_semr_b;
	sil_wrb_reg(p_semr_b, SEMR_SEMF_BIT);
}

/*
 *  ԥåμ
 */
Inline void
x_lock_spin(SPNLOCK *p_spn_lock)
{
	x_acquire_lock(p_spn_lock);
}

#define t_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)
#define i_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)

/*
 *  ԥåμλ
 */
Inline bool_t
x_try_lock_spin(SPNLOCK *p_spn_lock)
{
	uint8_t *p_semr_b = *p_spn_lock;

	if (test_and_set(p_semr_b)) {
		/*  */
		return(true);
	}
	else {
		/*  */
		Asm("":::"memory");
		return(false);
	}
}

/*
 *  ԥåֵ
 */
Inline void
x_unlock_spin(SPNLOCK *p_spn_lock)
{
	x_release_lock(p_spn_lock);
}


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
