/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007		by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  $Id: prc_support.S 861 2011-07-28 07:40:02Z mit-kimai $
 */

/*
 *	ץå¸⥸塼 ֥SH2A-DUALѡ
 *		ǥ󥰥롼
 *	 		ǥȤٱ䥹åȤɽ
 *	 		̿ᡧjmpjsrbrabsrrtsrtebf/sbt/sbsrfbraf
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val) 	(val)		 /* uint_tޥ */
#define ULONG_C(val)	(val)		 /* ulong_tޥ */
#define CAST(type, val) (val)		 /* 㥹ȤԤޥ */

/*
 *	֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

/*
 *	
 *	  0x80ʾˤʤĥ졢
 *	  Ԥưˤʤʤ
 */
#if !(TCB_p_tinib < 0x80)
#error	Range error!  Check (TCB_p_tinib < 0x80)
#endif

#if !(TCB_texptn < 0x80)
#error	Range error!  Check (TCB_texptn < 0x80)
#endif

#if !(TCB_sp < 0x80)
#error	Range error!  Check (TCB_sp < 0x80)
#endif

#if !(TCB_pc < 0x80)
#error	Range error!  Check (TCB_pc < 0x80)
#endif

#if !(TCB_enatex < 0x80)
#error	Range error!  Check (TCB_enatex < 0x80)
#endif

#if !(TCB_enatex_bit < 8)
#error	Range error!  Check (TCB_enatex_bit < 8)
#endif


/*
 *	ͥǤ߶ػ߻IPM
 *
 *	kernel_cfg.c Υ֥ǻ
 */
	.global _iipm_disall
_iipm_disall = IIPM_DISALL

/*
 *	ǥѥå
 *
 *	Υ롼ϡ
 *	 ƥ(excnest_count = 0)
 *	 CPUå
 *	 ǥѥåľ
 *	 ʥǥΡ˳ͥ٥ޥ
 *	ǸƤӽФ롥
 */

	.text
	.align 2
	.global _dispatch
_dispatch:
	/*
	 *	å쥸٤ƤΥ쥸¸
	 *	pr,r8r14򥹥å¸
	 *	r0r7ϸƤӽФ¸Ƥ뤿¸ɬפ̵
	 */
	movmu.l r8,@-r15
	stc gbr, r7						/*  r7my_p_pcb  */
	mov.l @(PCB_p_runtsk,r7),r0		/*  r0my_p_pcb->p_runtsk 	*/
	mov.l _dispatch_r_dis,r1		/*  r1¹ԺƳ   		*/
	mov.l r15,@(TCB_sp,r0)  /* åTCB¸ 60ʲʤOK */
	bra   _dispatcher
	 mov.l	r1,@(TCB_pc,r0)   /* ¹ԺƳϤTCB¸  60ʲʤOK	*/

_dispatch_r:
	/*
	 *	å쥸ν٤ƤΥ쥸
	 *	pr,r8r14򥹥å
	 */
	movmu.l @r15+,r8
	/*
	 *	㳰롼εư
	 *	dispatch_rdispatcherƤӽФ뤿ᡤ
	 *	tcbΥɥ쥹r0äƤ롥
	 */
	bld.b  #TCB_enatex_bit, @(TCB_enatex,r0)
	bt     _dispatch_r_check_texptn	/* enatextrueʤtexptnΥå */
	rts/n		/*  dispatch()θƤӽФإ꥿  */

	/* texptn0ǤʤipmflgtrueʤС㳰롼θƤӽФ */
_dispatch_r_check_texptn:
	mov.l  @(TCB_texptn,r0),r1		/* texptn */
	tst    r1,r1
	bf	   _dispatch_r_check_ipmflg
	rts/n		/*  dispatch()θƤӽФإ꥿  */

_dispatch_r_check_ipmflg:
	stc gbr, r7						/*  r7my_p_pcb  */
	mov.l @(PCB_ipmflg,r7),r1		/* ipmflg */
	tst    r1,r1
	bf	   _dispatch_r_call_texrtn
	rts/n		/*  dispatch()θƤӽФإ꥿  */


	/*
	 * 㳰롼θƤӽФ
	 * _call_texrtndispatch()θƤӽФإ꥿󤹤뤿ᡢ
	 * jmp̿ʬ롣
	 *pr쥸ˤϡdispatch()θƤӽФϤǼƤꡢ
	 *ǤϽ񤭴ʤ
	 */
_dispatch_r_call_texrtn:
	mov.l  _dispatch_call_texrtn_dis,r2
	jmp    @r2
	 nop

/*
 * ǥѥåưϡprc_support.S
 */
	.global _start_dispatch
_start_dispatch:
	/*
	 *	Υ롼ϡͥ뵯ưˡ
	 *	٤Ƥγߤػߤ֡ߥå֤Ʊ
	 *	sp󥿥ƥѥåݥ
	 *	ξ֤ǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *	prc_initializeǡ
	 *	lock_flagtrue
	 *	saved_iipmIIPM_ENAALL
	 *	˽Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
	 *	CPUå
	 *	ʥǥΡ˳ͥ٥ޥ
	 *	ˤʤ롥
	 *	ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
	 *	ѥåľ֤ˤʤäƤ롥
	 *
	 *	äơƥȤڤؤǤ褤
	 */
	mov   #0,r0
	bra   _dispatcher_0
	 mov.l r0, @(PCB_excnest_count,gbr)	/* excnest_count0  	*/

/*
 *	ߤΥƥȤΤƤƥǥѥå
 */
	.global _exit_and_dispatch
_exit_and_dispatch:
	/* ǥѥåΡdispatcherˤ */

/*
 * ǥѥå
 */
_dispatcher:
#ifdef LOG_DSP_ENTER
	mov.l _log_dsp_enter_dis, r1	/* ϴؿ */
	stc gbr, r8						/* r8my_p_pcb */
	jsr   @r1
	 mov.l @(PCB_p_runtsk,r8),r4
							/* r4my_p_pcb->p_runtsk */
#endif /* LOG_DSP_ENTER */
_dispatcher_0:
   /*
	*  ˤäΤϡ嵭_dispatcher¾ˡ
	*  2ս꤫ήƤ롣
	*	   _start_dispatch
	*	   _dispatcher_2ʼ¹Ԥ٤ʤԤξ
	*
	*  Υ롼ϡ
	*	   ƥ
	*	   CPUå
	*	   ǥѥåľ
	*	   ʥǥΡ˳ͥ٥ޥ
	*  ǸƤӽФ롥
	*
	*  ʤ
	*	   excnest_count=0
	*	   lock_flag=true
	*	   disdsp=false
	*	   dspflg=true
	*	   saved_iipm=IIPM_ENAALL
	*ȤʤäƤ롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
	*/
	stc gbr, r7						/* r7my_p_pcb  */
	mov.l @(PCB_p_schedtsk,r7),r8	/* r8 <- my_p_schedtsk 			*/
	tst    r8,r8					/* my_p_schedtsk 뤫		*/
	bt/s  _dispatcher_1				/* my_p_schedtsk̵Х 	*/
	 mov.l r8, @(PCB_p_runtsk,r7)	/* my_p_runtskmy_p_schedtsk	*/
	mov.l @(TCB_sp,r8),r15 			/* TCB饿å	*/
#ifdef LOG_DSP_LEAVE
	mov.l _log_dsp_leave_dis, r1 	/* ϴؿ */
	jsr   @r1
	 mov   r8, r4					/* 	  */
#endif /* LOG_DSP_LEAVE */
	mov.l  @(TCB_pc,r8),r1		/* TCB¹ԺƳϤ		*/
	jmp    @r1
	 mov   r8, r0
		/*
		 *  ʬʼ¹ԺƳϡˤǤϡr0my_p_schedtsk
		 *  Ǽ줿֤ꤷƤ롣
		 */

	/* 
	 * ¹Ԥ٤ʤγԤ
	 */
_dispatcher_1:
	/* 
	 * ߥǥͤɤ߹ΤϸΨΤǻѰդ
	 * ׸Ƥ쥸ƤθľASPchangeset/1658
	 * 
	 * r0  : 0x00ʳߤĤȤˤϤͤSRꤹ
	 * r1  : 0x01
	 * r2  : ߶ػߤΤSR
	 * r8  : my_p_pcb
	 * r12 : _sleep_end
	 */
	mov    #0,r0
	mov    #1,r1
	mov.l  _iipm_disall_dis,r2		/* ߶ػ߻SR */
	stc    gbr, r8					/* r8my_p_pcb */
#ifndef OMIT_POWER_CONTROL
	mov.l _sleep_end_dis, r12
#endif /* OMIT_POWER_CONTROL */
	/*
	 *  ߤĤ顢CPUå֤ˤʤ褦
	 *  my_p_tacb->lock_flagfalse
	 */
	mov.l r0, @(PCB_lock_flag,gbr)
	/*
	 *	󥿥ƥȤڤؤ
	 *	
	 *	󥿥ƥȤڤ괹Τϡȯ
	 *	߽ˤɤΥåȤȤβȡߥϥɥ
	 *	ǤΥǥѥåɻߤȤĤΰ̣롥
	 */
	mov.l r1, @(PCB_excnest_count,r8)	/* excnest_count1  	*/
	mov.l @(PCB_istkpt,r8),r15			/* åؤ		*/
_dispatcher_2:
	/*
	 *Ԥ
	 *
	 *ǥѥåνиǼ¹Ԥ٤ʤ(schedtsk==
	 *NULL˾ϡsleep̿ˤäƥץåϥ⡼ɤ
	 *ؤƳԤ򤷤Ƥ롣
	 *
	 *ߵĸsleep̿¹ԤƤ뤿ᡢߵ̿
	 *¹˳׵᤬äƤʤ뤤ϳߵľ塢
	 *sleep̿¹˳׵᤬äˡߵ̿
	 *¹Ԥȶ˳ߤդ졢sleepޤޤ
	 *ʤꡢreqflgΥå˿ʤޤʤ
	 *1msec˥޳ߤ뤿ᡢºݤˤsleepޤޤ
	 *ȤϤʤ
	 *
	 *ϡߤεĤsleep֤ؤΰܹԤȥߥå˼
	 *ԤǤʤȤ˵롣
	 *
	 *	褹뤿ᡤrte̿ΡPC,SRٱ䥹åȤ
	 *	̿򡢳ߤȤԲʬ˼¹ԤפȤͤѤ
	 *	ߤεĤȾϥ⡼ɤؤΰܹԤԲʬ˹Ԥ
	 */
#ifdef OMIT_POWER_CONTROL
	ldc    r0,sr				/*  ߵ 				  */
	ENAINT_NOP					/*  CPUINTCãޤǤٱ  */
	
#else /* OMIT_POWER_CONTROL */
	mov.l r0, @-r15				/*	SRꤹͤ򥹥åѤ	*/
	mov.l r12, @-r15			/*	Ϥ򥹥åѤ  */
	/*
	 *ߵĤʥåɤ߽ФͤSRꤹ
	 *Ʊ˾ϥ⡼ɤذܹԤ롣
	 *
	 *׸Ƥ
	 *եȥХ⡼ɤ˰ܹԤ
	 *ХơȥȥΥ饤ȥХåե
	 *RAMؤν񤭹ߤλȤǧ롣
	 *ʳRAMؤΥߡ꡼ɤԤ
	 */
	rte
	 sleep						/*	ٱ䥹åȡ  */

_sleep_end:
#endif /* OMIT_POWER_CONTROL */
	ldc    r2,sr				/* ͥγߤػ	   */
	/*
	 *LDC Rm,SR̿λ
	 *ľ̿¹Ի˳׵᤬äο
	 *
	 *SH-2E
	 *ľ̿᤬߶ػߤǼ¹Ԥ롣
	 *
	 *SH-2Aʹ
	 *LDC Rm,SR̿ꤷߥޥSRIӥåȡˤȿǤ
	 *ľ̿¹Ի˳ߤդ뤫ݤޤ롣
	 *
	 *äơʲΥ󥹤Ǥϡɤξ̿ᣱ
	 *߶ػߤǼ¹ԤΤǡnop̿ɬפϤʤ
	 *
	 *  mov  #f0, r0
	 *  ldc  r0, sr
	 *̿ᣱ
	 */
	mov.l @(PCB_reqflg,r8),r6	/* r6 <- my_p_pbc->reqflg		   */
	tst   r6,r6					/* reqflg  falseʤ			   */
	bt	  _dispatcher_2			/* dispatcher_2 			   */
	mov.l r0, @(PCB_reqflg,gbr)	/* reqflgfalse				   */
	/*
	 *	ƥȤڤؤ
	 *	åڤؤϡʬ_dispatcher_0ǹԤ
	 */
	mov.l r0, @(PCB_excnest_count,gbr)	/* excnest_count 򥯥ꥢ	*/
	
	/*
	 *	CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
	 *	ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
	 *	פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
	 *	ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
	 *	Ф褤
	 */
	mov.l r1, @(PCB_lock_flag,r8)		/* lock_flagtrue */
	bra    _dispatcher_0
	 mov.l r0, @(PCB_saved_iipm,gbr)	/* saved_iipm0 */


    /*
     *  Υޥ졼
     *  ѥ᡼Ȥr4˥ޥ졼ΥץåID
     *  ǼƤΤǡmigrate_selfƤӽФޤǡ
     *  ˲ƤϤʤ
     */
    .text
    .align 2
    .global _dispatch_and_migrate
_dispatch_and_migrate:
	/*
	 *	å쥸٤ƤΥ쥸¸
	 *	pr,r8r14򥹥å¸
	 *	r0r7ϸƤӽФ¸Ƥ뤿¸ɬפ̵
	 */
	movmu.l r8,@-r15
	mov.l @(PCB_p_runtsk,gbr),r0	/*  r0my_p_pcb->p_runtsk 	*/
	mov.l _dispatch_r_dis,r1		/*  r1¹ԺƳ   		*/
	mov.l r15,@(TCB_sp,r0)  /* åTCB¸ 60ʲʤOK */
	mov.l r1,@(TCB_pc,r0)   /* ¹ԺƳϤTCB¸  60ʲʤOK	*/
    mov.l p_migrate_self, r2
	stc   gbr, r8			/* r8my_p_pcb */
    jsr   @r2		/*  ѥ᡼r4ޥ졼ΥץåID  */
	 mov.l @(PCB_istkpt,r8),r15
							/* 󥿥ƥѥåڤؤ */

    .align 2
_iipm_disall_dis:
	.long _iipm_disall

    /*
     *  ߤΥƥȤΤƥޥ졼
     */
    .text
    .align 2
    .global _exit_and_migrate
_exit_and_migrate:
    mov.l p_exit_and_migrate_self, r2
	stc   gbr, r8	/* r8my_p_pcb */
    jsr   @r2		/* exitȥޥ졼롼 */
    				/*  ѥ᡼r4ޥ졼ΥץåID  */
	 mov.l @(PCB_istkpt,r8),r15
					/* 󥿥ƥѥåڤؤ */

	.align 2
_dispatch_r_dis:
	.long _dispatch_r
_dispatch_call_texrtn_dis:
	.long _dispatch_call_texrtn
#ifndef OMIT_POWER_CONTROL
_sleep_end_dis:
	.long _sleep_end
#endif /* OMIT_POWER_CONTROL */
#ifdef LOG_DSP_ENTER
_log_dsp_enter_dis:
	.long _log_dsp_enter
#endif /* LOG_DSP_ENTER */
#ifdef LOG_DSP_LEAVE
_log_dsp_leave_dis:
	.long _log_dsp_leave
#endif /* LOG_DSP_LEAVE */

p_migrate_self:
    .long _migrate_self
p_exit_and_migrate_self:
    .long _exit_and_migrate_self


/*
 *	ͥνλθƽФ
 *
 *	å󥿥ƥѤڤؤ
 *	exit_kernelʬ롣
 *	δؿϡߥå֤ǸƤФ
 */
	.global _call_exit_kernel
_call_exit_kernel:
	mov.l _exit_kernel_exit,r0
	stc   gbr, r7					/* r7my_p_pcb */
	jmp   @r0
	 mov.l @(PCB_istkpt,r7),r15	/* åڤؤ		   */

	.align 2
_exit_kernel_exit:
	.long _exit_kernel


/*
 *	ư
 *
 *	ǥѥå㤫顢ʲξ֤Ǥˤ롣
 *  ƥ
 *  CPUå
 *  ͥ٥ޥ
 *  ǥѥåľ
 *  r0my_p_runtsk
 */
	.text
	.global _start_r
_start_r:
	/*
	 *  ߤĤ顢CPUå֤ˤʤ褦
	 *  my_p_tacb->lock_flagfalse
	 */
	mov    #0,r2
	stc    gbr, r7				 /* r7my_p_pcb */
	mov.l  r2, @(PCB_lock_flag, r7)
	ldc    r2,sr				 /* ߵ */
	mov.l  @(TCB_p_tinib,r0),r3  /* r3my_p_runtsk->p_tinib  */
	mov.l  _ext_tsk_start,r5
	mov.l  @(TINIB_task,r3),r1	 /* r1ư	 */
	lds    r5,pr				 /* Ϥ */
	jmp    @r1
	 mov.l @(TINIB_exinf,r3),r4  /* exinf쥸r4  */

	.align 2
_ext_tsk_start:
	.long _ext_tsk


/*
 *  ߤκݤΥåݥ󥿤ؤ֤SR,PCΥԡ
 *  ޤǤΥեå
 *
 *SP_PC_OFFSET_INT_ret_int_2λǤΡåѤޤ줿
 *PCؤΥեå
 *SP_SR_OFFSET_INT_ret_int_3λǤΡåѤޤ줿
 *SRؤΥեå
 *
 *
 * åڤؤΥå
 * ʳ߼ջΥƥѥå
 *
 * (1) 쥸Х󥯤Ѥʤ
 *        ----------------------
 *  0    |         PR           |   <-- _ret_int_2 / _ret_int_3 λ
 *        ----------------------
 *  1    |        MACH          |
 *        ----------------------
 *  2    |        MACL          |
 *        ----------------------
 *  3    |         R0           |
 *        ----------------------
 *  4    |         R1           |
 *        ----------------------
 *  5    |         R2           |
 *        ----------------------
 *  6    |         R3           |
 *        ----------------------
 *  7    |         R4           |
 *        ----------------------
 *  8    |         R5           |
 *        ----------------------
 *  9    |         R6           |
 *        ----------------------
 * 10    |         R7           |
 *        ----------------------
 * 11    |         PC           |
 *        ----------------------
 * 12    |         SR           |
 *        ----------------------
 *
 * (2) 쥸Х󥯤Ѥ
 *        ----------------------
 *  0    |         PR           |   <-- _ret_int_3 λ
 *        ----------------------
 *  1    |        MACH          |
 *        ----------------------
 *  2    |        MACL          |
 *        ----------------------
 *  3    |         R0           |
 *        ----------------------
 *  4    |         R1           |
 *        ----------------------
 *  5    |         R2           |
 *        ----------------------
 *  6    |         R3           |
 *        ----------------------
 *  7    |         R4           |
 *        ----------------------
 *  8    |         R5           |
 *        ----------------------
 *  9    |         R6           |
 *        ----------------------
 * 10    |         R7           |
 *        ----------------------
 * 11    |         PC           |   <-- _ret_int_2 λ
 *        ----------------------
 * 12    |         SR           |
 *        ----------------------
 */
#ifdef USE_BANKED_REG
#define    SP_PC_OFFSET_INT    0
#else /* USE_BANKED_REG  */
#define    SP_PC_OFFSET_INT    (11*4)
#endif /* USE_BANKED_REG */

#define    SP_SR_OFFSET_INT    (12*4)


/*
 *	̳ߤ
 *װ˰ͤ餺̤ʬ
 *ʥե졼kernel_cfg_asm.Sˤ
 *³
 *	
 *	װŸ롼r4,r5,r6,r7¸
 *r5ֹ
 *r6ߥϥɥƬɥ쥹
 *r7߼ľSRΥԡ
 *	ξ֤Ǥ롣
 *	r4˳ƤʤΤϡCPU㳰ϥɥνȤʤ٤̤ˤ뤿
 */
	.text
	.global _interrupt_entry
_interrupt_entry:
#ifndef  USE_BANKED_REG
    movml.l r3, @-r15	/*  ĤΥå쥸򥹥åѤ  */
    sts.l  mach,@-r15
    sts.l  macl,@-r15
    sts.l  pr,@-r15
#endif /* USE_BANKED_REG */
							/* /CPU㳰ͥȥ󥿤Υå */
	stc    gbr, r3				/* r3my_p_pcb */
	mov.l  @(PCB_excnest_count, r3),r1
	tst    r1,r1				/* ȯΥƥȤȽ  */
	add    #0x1,r1				/* ߥͥȥ󥿤򥤥󥯥 */
    bf/s   _interrupt_entry_1   /* ¿ųߤʤ饸  */
	 mov.l  r1, @(PCB_excnest_count, r3)
	mov    r15,r2				/* åڤؤ*/
	mov.l  @(PCB_istkpt, r3),r15
	mov.l  r2,@-r15 			 /* å¸ */
_interrupt_entry_1:
	ldc    r7,sr				 /* ߵ	*/
	/*
	 * ֹ¸
	 * ¸ֹˤϡĤΰ̣롣
	 * default_int_handlerΰ
	 * log_inh_leave_intΰ
	 */
	mov.l  r5,@-r15

#ifdef LOG_INH_ENTER
	mov.l _log_inh_enter_int, r1 /* ϴؿ */
	mov.l  r6,@-r15 	  /* r6ʳߥϥɥƬɥ쥹¸ */
	jsr   @r1
	 mov  r5, r4				 /* 		  */
	mov.l @r15+, r6 			 /* r6		  */
#endif /* LOG_INH_ENTER */

	jsr    @r6					 /* ߥϥɥƤӽФ  */
#ifndef LOG_INH_LEAVE
	  mov.l @r15+,r4			 /* default_int_handlerѤΰ */
	  							 /*  ʳֹ  */
#else  /* LOG_INH_LEAVE */
	  mov.l  @r15, r4			 /* default_int_handlerѤΰ */
	  							 /*  ʥåϤΤޤޡ   */
	mov.l _log_inh_leave_int, r1 /* ϴؿ				*/
	jsr  @r1
	 mov.l @r15+,r4 			 /* ֹ			*/
#endif /* LOG_INH_LEAVE */

	/*
	 * ߥϥɥи
	 *
	 *	/CPU㳰ͥȥ󥿤ǥȤΥƥ
	 *	ȤȽꤷƥåؤ롥
	 *	ͥγߤ򥵥ݡȤϡξԤδ֤˥ͥ
	 *	γߤ礬롥ͥγߤϡ
	 *	ͥγߤƱͤǤ뤿ᡤ/CPU㳰ͥȥ
	 *	󥿤򻲾Ȥơåؤ롥Τᡤ/CPU㳰
	 *	ͥȥ󥿤ȥåؤϥͥγߤ
	 *	Ƥ⡤Բʬ˹Ԥɬפ롥
	 */
_ret_int:
	movi20 #IIPM_DISALL,r2	/*  ߡʥͥޤ˶ػ  */
	ldc    r2,sr
    /*
     */CPU㳰ͥȥ󥿤ǥȤ
     *褬󥿥ƥȤʤ餹˥꥿
     */
	stc    gbr, r7				 /* r7my_p_pcb */
	mov.l  @(PCB_excnest_count, r7),r1
	dt     r1
	mov.l r1,@(PCB_excnest_count, r7)
	bf    _ret_int_1			 /* 32ӥå̿ʤΤǡٱ䥹åȤ֤Ǥʤ */

	mov.l  @r15,r15 			 /* 褬ʤΤǥå᤹	   */
	mov.l  @(PCB_reqflg, r7),r1	 /* reqflgΥå */
	tst    r1,r1				 /* 	reqflgfalseʤret_int_1	   */
	bt	   _ret_int_1
	/*
	 * 褬reqflgåȤƤνʬ
	 * ret_int_2ʬƥǥѥåʤ礬Τreqflgϥꥢʤ
	 */
	movi20 #IIPM_LOCK,r0
#ifdef TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION
	ldc    r0,sr				 /* ͥγߤ			  */
	bra   _ret_int_2
	 nop
#else	/* TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION */
	bra   _ret_int_2
	 ldc	r0,sr				  /* ͥγߤ			  */
#endif	/* TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION */


	/*
	 *	߽Υ꥿
	 *	ǥѥå䥿㳰롼ƤӽФ
	 *	ľܡ߸إ꥿󤹤롣
	 *	٤쥸쥸Х󥯤˳ǼƤ
	 *	_ret_int_r_returnȰۤʤ롣
	 */
_ret_int_1:
	/*
	 *	߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
	 *	롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
	 *	lock_flagfalseˤƤФ褤lock_flagfalseˤΤϡ
	 *	CPUå֤Τޤ޳ߥϥɥ餫äкˡ
	 */
	mov    #0x0, r1
	stc    gbr, r7						/* r7my_p_pcb */
	mov.l  r1,@(PCB_lock_flag,r7)

#ifdef USE_BANKED_REG
	resbank
#else	/*  USE_BANKED_REG  */
	lds.l  @r15+,pr
	lds.l  @r15+,macl
	lds.l  @r15+,mach
	movml.l @r15+,r7
#endif	/* USE_BANKED_REG */
	rte
	 nop

	.align 2
#ifdef LOG_INH_ENTER
_log_inh_enter_int:
	.long  _log_inh_enter
#endif /* LOG_INH_ENTER */
#ifdef LOG_INH_LEAVE
_log_inh_leave_int:
	.long  _log_inh_leave
#endif /* LOG_INH_LEAVE */

	/*
	 *	ؤϳߥϥɥνиʬƤ
	 *	
	 *	褬reqflgåȤƤΤߤˤ롣
	 */
_ret_int_2:
	/*
	 *CPU㳰/߼ľ˳߶ػߤˤʤäƤʤȤؤк
	 *褬ߡCPU㳰ݤȽ̡
	 *
	 *SH2A-DUALǤCPU㳰/߼ľ˳߶ػߤˤʤäƤʤᡢ
	 *	A̤γBǽ롣
	 * ʤϥϡɥΥƥ򤱤褦ʤ
	 *	ߥϥɥBǥڤؤ򵯤褦ʥӥ
	 *	Ƥ֤ȳBνи̤Υ˥ǥѥåƤޤ
	 *	2鸵ΥäƤޤǡAν٤Ƥ
	 *	ޤ
	 *	ɤᡢ/㳰ޤȤvector_entry
	 *	֤Υɥ쥹ϰʤǥѥå
	 *	˥꥿󤹤롥
	 */
	mov.l  @(SP_PC_OFFSET_INT,r15),r0	/* r0 <-åѤޤ줿pc */
	mov.l  _vector_entry_start_ret, r1
	mov.l  _vector_entry_end_ret, r2
	cmp/hs r1, r0
	bf	   _ret_int_2_1
	cmp/hi r0, r2
	bt	   _ret_int_1

	/*
	 *	ǥѥå⤷ϥ㳰θƤӽФ
	 */
_ret_int_2_1:
	/*
	 *	쥸Х󥯤Ѥϥå쥸
	 *	å˳Ǽ
	 */
#ifdef USE_BANKED_REG
	resbank
	movml.l  r7, @-r15
	sts.l	 mach,@-r15
	sts.l	 macl,@-r15
	sts.l	 pr,@-r15
#endif /* USE_BANKED_REG */

	/*
	 *	ǥѥåθƤӽФ
	 *
	 *	ؤϡCPU㳰ϥɥνиʬƤ롥
	 *
	 *	Ǥϡ褬Ǥꡤåϡå
	 *	å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *	ͥγߤػߤ֤ȤʤäƤ롥
	 */
_ret_int_3:
	/*
	 *reqflgΥꥢ
	 *
	 *ãreqflg򥯥ꥢƤޤȡ嵭γA
	 *νиǥǥѥåƤӽФɬפʥǤǥ
	 *ѥå㤬ƤӽФʤ
	 *ʳBreqflg򥻥åȤơAreqflgѲʤ
	 *
	 */
	mov    #0x0, r0
	stc    gbr, r7					/*  r7my_p_pcb */
	mov.l  r0, @(PCB_reqflg, r7)	/*  reqflgfalse  */

	/*
	 *	CPUå֤˰ܹԤ롥ͥγߤϴ˶ػߤ
	 *	Τǡlock_flagsaved_iipm򹹿롥saved_iipmϡ
	 *	γͥ٥ޥʤɽˤꤹ롥
	 *
	 *	λCPUå֤ȤΤϡdispatcherʬȡ
	 *	dispatch_call_texrtnƤӽФˡCPUå֤ˤʤäƤ
	 *	ɬפ뤿Ǥ롥
	 */
	mov    #0x01,r1
	mov.l  r1,@(PCB_lock_flag,r7)	/* lock_flagtrue */

	/*
	 * å¸ƤIPMФơsaved_iipm
	 *
	 *ƥȤΤˡñsaved_iipm0Ȥʤ
	 *ʥå¸ƤSR虜虜IPMФˤΤϡ
	 *ȯΥƥȤchg_ipm¹Ԥ
	 *ͥ٥ޥ֤Ǥʤ֤ǡ/CPU㳰
	 *ȯãб뤿Ǥ롣
	 */
	mov.l  @(SP_SR_OFFSET_INT,r15),r0
	and    #0xf0,r0		/* and #imm,r0̿r0Τ߻ǽ  */
	mov.l  r0,@(PCB_saved_iipm,gbr)
			/* saved_iimpåѤޤƤSRIPM  */

	/*
	 *	dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *	ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *	롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *	reqflgtrueˤ뤿Ǥ롥
	 */
	mov.l  @(PCB_dspflg,r7),r3	  /* r3 <- dspflg					*/
	mov.l  @(PCB_p_runtsk,gbr),r0 /* r0 <- p_runtsk					*/
	tst    r3,r3
	bt	   _ret_int_r_1			/* dspflgfalseʤret_int_r_1 	*/
	mov.l  @(PCB_p_schedtsk,r7),r5 /* r5 <- p_schedtsk				*/
	cmp/eq r0,r5				/* runtsk  schedtsk 	 	*/
	bt	   _ret_int_r_1 		/* Ʊʤret_int_r_1		 	*/
	/*
	 *	
	 *	r8-r14˲äơprʣƥå¸뤬
	 *	_ret_int_r¦ɤ߽ФȤˤ⡢礵ƤΤʤ
	 */
	movmu.l r8, @-r15			/*  r8-r14,pr򥹥å¸  	*/
	mov.l  r15,@(TCB_sp, r0)	/* åTCB¸	  */
	mov.l  _ret_int_r_ret,r3
	bra    _dispatcher
	 mov.l	r3,@(TCB_pc, r0)	/* ¹ԺƳϤTCB¸		  */

_ret_int_r:
	/*
	 *	
	 *	ʬƤΤ_ret_int_3ΤߤǤ롣
	 *	_ret_int_3¦r8-r14˲äơpr⥹å¸Ƥ롣
	 */
	movmu.l @r15+,r8			/*  r8-r14,pr򥹥å  */
_ret_int_r_1:
	/*
	 *	㳰롼εư
	 *	ret_int_r  dispatcher ƤӽФ뤿ᡤtcbΥɥ쥹r0
	 *	äƤ롥
	 *	ʤߤνиǥåȯʤϥǥѥå
	 *	̤餺 ret_int ľ ret_int_1 
	 */
	/*  enatexΥå  */
	bld.b  #TCB_enatex_bit, @(TCB_enatex,r0)
	bf     _ret_int_r_return	/* enatexfalseʤȯإ꥿ */

	/* texptn0̵ipmflgtrueʤС㳰롼θƤӽФ */
	mov.l  @(TCB_texptn,r0),r1	/* texptn */
	tst    r1,r1
	bt	   _ret_int_r_return	/* texptn0ʤȯإ꥿  */

_ret_int_r_check_ipmflg:
	stc gbr, r7						/*  r7my_p_pcb  */
	mov.l @(PCB_ipmflg,r7),r1		/* ipmflg */
	tst    r1,r1
	bt	   _ret_int_r_return	/* ipmflgfalseʤȯإ꥿  */

	mov.l  _dispatch_call_texrtn_ret,r2
	jsr/n  @r2					/* 㳰롼θƤӽФ */

	/*  ȯإ꥿  */
_ret_int_r_return:
	mov    #0x0,r0					/* lock_flagfalse */
	lds.l  @r15+,pr
	mov.l  r0, @(PCB_lock_flag,gbr)
	lds.l  @r15+,macl
	lds.l  @r15+,mach
	movml.l @r15+,r7
	rte
	 nop

	.align 2
_ret_int_r_ret:
	.long _ret_int_r
_dispatch_call_texrtn_ret:
	.long _dispatch_call_texrtn
_vector_entry_start_ret:
	.long __vector_entry_start
_vector_entry_end_ret:
	.long __vector_entry_end

/*
 *	CPU㳰
 *
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥ΤᡤCPU
 *  ϥɥƤӽФ󥿥ƥȤؤ꥿󤷤
 *  ˸ΥƥȤ᤹ΥƥȤ᤹ˡ
 *  åؤΥåΥåݥ󥿤󥿥
 *  ƥѥå¸롥
 *  CPU㳰ƥȤȯreqflg  true ˤʤäˡ
 *  _ret_exc_2 ʬ롥
 *	reqflg å˳ߤػߤʤȡreqflg å
 *	˵ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥ
 *	ѥåʤ
 *	
 *	̿ξϤ2Хȿʤɬפ뤬
 *	бƤʤ
 *	
 *	CPU㳰װŸ롼r4,r5,r6,r7¸
 *	 r5  CPU㳰ϥɥֹ
 *	 r6  CPU㳰ϥɥƬɥ쥹
 *	 r7  CPU㳰ȯSRΥԡ
 *	ξ֤Ǥ롣
 *	
 * (1) CPU㳰ȯΥƥѥå
 *		  ----------------------
 *	0	 | CPU㳰ϥɥֹ	|	<-- p_excinfCPU㳰ϥɥΰˡ
 *		  ----------------------		_ret_exc_non_taskλCPU㳰ȯ󥿥ƥȤξ
 *	1	 |		   PR			|	<-- _ret_exc_1/_ret_exc_2λ
 *		  ----------------------
 *	2	 |		  MACH			|
 *		  ----------------------
 *	3	 |		  MACL			|
 *		  ----------------------
 *	4	 |		   R0			|
 *		  ----------------------
 *	5	 |		   R1			|
 *		  ----------------------
 *	6	 |		   R2			|
 *		  ----------------------
 *	7	 |		   R3			|
 *		  ----------------------
 *	8	 |		   R4			|  <-- sp_exception_entryλ
 *		  ----------------------
 *	9	 |		   R5			|
 *		  ----------------------
 * 10	 |		   R6			|
 *		  ----------------------
 * 11	 |		   R7			|
 *		  ----------------------
 * 12	 |		   PC			|	<-- spCPU㳰ľλ
 *		  ----------------------
 * 13	 |		   SR			|
 *		  ----------------------
 *	
 * (2) ƥڤؤ󥿥ƥѥå
 *		  ----------------------
 *		 |	 CPU㳰ϥɥ	|log_exc_enterƤӽФ
 *		 |	 Ƭɥ쥹(r6)	|
 *		  ----------------------
 *		 |	   p_excinf(r4) 	|log_exc_enterƤӽФ
 *		  ----------------------
 *		 | CPU㳰ϥɥֹ	|log_exc_leaveƤӽФ
 *		  ----------------------
 *		 |	   saved_iipm		|  <-- sp_ret_excλ
 *		  ----------------------
 *		 |	   lock_flag		|
 *		  ----------------------
 *		 |	   locspinid		|
 *		  ----------------------
 *		 | åsp	|ʥåؤ򤷤
 *		  ----------------------
 */

/*
 *	_ret_exc_2λǡåݥ󥿤ͤ
 *  ֥åѤޤƤCPU㳰ϡפޤǤΥեå
 */
#define    SP_PC_OFFSET_EXC     (11 * 4)

	.text
	.global _exception_entry
_exception_entry:
	movml.l r3,@-r15 	/*	ĤΥå쥸򥹥åѤ  */
	sts.l  mach,@-r15
	sts.l  macl,@-r15
	sts.l  pr,@-r15
	mov.l  r5,@-r15 			/* CPU㳰ϥɥֹ¸  */
								/* /CPU㳰ͥȥ󥿤Υå */
	stc    gbr, r3				/* r3my_p_pcb */
	mov.l  @(PCB_excnest_count,r3), r1
	mov    r15, r4				 /* CPU㳰ϥɥؤΰ */
	tst    r1,r1				 /* ȯΥƥȤȽ	 */
	add    #0x1,r1				 /* /CPU㳰ͥȥ󥿤򥤥󥯥 */
    bf/s   _exception_entry_1    /* CPU㳰ȯ󥿥ƥȤʤ饸 */
	 mov.l r1, @(PCB_excnest_count,r3)
	mov.l @(PCB_istkpt,r3),r15	 /* 󥿥åڤؤ			 */
	mov.l  r4,@-r15 			 /* åݥ󥿤¸ */
_exception_entry_1:
    /*
     * Υԥå֡CPUå֤֡򥹥å¸
     */
	mov.l  @(PCB_locspnid, gbr), r0
	mov.l  @(PCB_lock_flag, r3), r1
	mov.l  @(PCB_saved_iipm,r3), r2
	mov.l  r0,@-r15
	mov.l  r1,@-r15
	mov.l  r2,@-r15

#ifdef LOG_EXC_LEAVE
	mov.l  r5,@-r15 			 /* CPU㳰ϥɥֹ¸ */
#endif /* LOG_EXC_LEAVE */

#ifdef LOG_EXC_ENTER
	ldc    r7,sr				 /* ߵ	*/
	mov.l _log_exc_enter_exc, r1 /* ϴؿ  */
	mov.l  r4,@-r15 			 /* r4¸CPU㳰ϥɥΰ */
	mov    r5, r4				 /* CPU㳰ϥɥֹ*/
	jsr   @r1
	 mov.l  r6,@-r15 			 /* r6¸CPU㳰ϥɥƬɥ쥹*/

	mov.l @r15+, r6 			 /* r6		  */
	jsr    @r6					 /* CPU㳰ϥɥƤӽФ  */
	 mov.l @r15+, r4			 /* r4		  */
#else /* LOG_EXC_ENTER */

#ifdef TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION
	ldc    r7,sr				 /* ߵ	*/
	jsr    @r6					 /* CPU㳰ϥɥƤӽФ  */
	 nop
#else	/* TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION */
	jsr    @r6					 /* CPU㳰ϥɥƤӽФ  */
	 ldc	r7,sr				 /* ߵ	*/
#endif	/* TOPPERS_LDC_IS_SLOT_ILLEGAL_INSTRUCTION */

#endif /* LOG_EXC_ENTER */

#ifdef LOG_EXC_LEAVE
	mov.l _log_exc_leave_exc, r1 /* ϴؿ						*/
	jsr  @r1
	 mov.l @r15+, r4             /* CPU㳰ϥɥֹ           */
#endif /* LOG_EXC_LEAVE */

	/*
	 * CPU㳰ϥɥи
	 */
_ret_exc:
	/*
	 * ׸Ƥ
	 * excnestιȥåڤؤԲʬ˹Ԥˤϡ
	 * ͥγߤػߤɬפ롣
	 * ͥγߤ̵ͭǽѤ롣
	 */
	movi20 #IIPM_DISALL, r0				/* ߶ػ	 */
	ldc    r0,sr
    /*
     * ԥå֡CPUå֤֡򸵤ξ֤᤹
     */
	stc    gbr, r7						/* r7my_p_pcb */
    mov.l  @r15+,r0						/* saved_iipm */
    mov.l  @r15+,r1						/* lock_flag  */
    mov.l  @r15+,r2						/* locspinid  */
	mov.l  r0, @(PCB_saved_iipm,gbr)
	mov.l  r1, @(PCB_lock_flag, r7)
	tst    r2,r2
	mov.l  r2, @(PCB_locspnid, r7)
	
	/*  locspinid=0ʤСforce_unlock_spin(my_p_pdb)ƤӽФ  */
	bf     _ret_exc_after_force_unlock_spin
	mov.l  _force_unlock_spin_exc, r3
	jsr    @r3
	 stc   gbr, r4					/*  my_p_pdb  */
_ret_exc_after_force_unlock_spin:

    /*
     * ƥڤؤ
	 * ֥åѤޤ줿CPU㳰ϥɥֹɤФ׽ʥ
	 * åݥ󥿤Υ󥯥ȡˤϥåڤؤǤʤ
	 * ǤʤᡢΥƥȽ塢2սǹԤäƤ롣
	 * ʥåڤؤľ_ret_exc_non_task
     */
	/*
	 *	׸Ƥ
	 *	ȯͥγߤ˲ʤ褦
	 */
    /*  ׸Ƥ顢Բʬ  */
	mov    r15,r2
    /*
     */CPU㳰ͥȥ󥿤ǥȤ
     *褬󥿥ƥȤʤ餹˥꥿
     */
	stc    gbr, r7					/* r7my_p_pcb */
	mov.l  @(PCB_excnest_count,r7), r1
    dt     r1
    bf/s   _ret_exc_non_task
	 mov.l r1, @(PCB_excnest_count,r7)

	mov.l  @r2,r15			/* 褬ʤΤǥå᤹	  */
    /*  ׸ƤޤǡԲʬ  */

	mov.l  @(PCB_reqflg,r7), r1	/* reqflgΥå */
	add    #4, r15
		/* åѤޤ줿CPU㳰ϥɥֹɤФ */
	
	/*
	 *reqflgtrueʤret_exc_2
	 *ret_exc_2ʬƥǥѥåʤ礬Τreqflg
	 *ꥢʤ
	 */
	tst    r1,r1
	bf	  _ret_exc_2


    /*
	 *ǥѥåƤФ˥꥿󤹤
     */
_ret_exc_1:
	lds.l  @r15+,pr
	lds.l  @r15+,macl
	lds.l  @r15+,mach
	movml.l @r15+,r7
	rte
	 nop

	/*
	 *褬󥿥ƥ
	 *åѤޤƤCPU㳰ϥɥֹɤФ
	 *_ret_exc_1ʬ
	 */
_ret_exc_non_task:
	bra    _ret_exc_1
	 add   #4, r15
	 	/* åѤޤ줿CPU㳰ϥɥֹɤФ */

	/*
	 *褬ƥȤǡreqflg=trueξ
	 *ʥǥѥåޤϥ㳰롼θƤӽФ
	 *
	 *ߤξ_ret_int_2ˤȶ̤ˤǤʤΤϡ
	 *쥸Х󥯤ꡢ쥸Υߥ󥰤ۤʤ뤿ᡣ
	 */
_ret_exc_2:
	/*
	 *褬ߡCPU㳰ݤȽ
	 *	ܤret_int_2򻲾ȤΤ
	 */
	mov.l  @(SP_PC_OFFSET_EXC,r15),r0	/* r0 <-åѤޤ줿PC */
	mov.l  _vector_entry_start_exc, r1
	mov.l  _vector_entry_end_exc, r2
	cmp/hs r1, r0
	bf	   _ret_exc_2_1			/*  ǥѥåƤӽФ  */
	cmp/hi r0, r2
	bt	   _ret_exc_1			/*  ǥѥåƤФ˥꥿  */

_ret_exc_2_1:
	bra    _ret_int_3			/*  ߤξȶ̤ν  */
	 nop
	
	.align 2
_force_unlock_spin_exc:
	.long  _force_unlock_spin
_vector_entry_start_exc:
	.long __vector_entry_start
_vector_entry_end_exc:
	.long __vector_entry_end
#ifdef LOG_EXC_ENTER
_log_exc_enter_exc:
	.long _log_exc_enter
#endif /* LOG_EXC_ENTER */
#ifdef LOG_EXC_LEAVE
_log_exc_leave_exc:
	.long _log_exc_leave
#endif /* LOG_EXC_LEAVE */

/*
 *	̤Ͽγߥϥɥ
 *	װr7,r6¸
 *	r6˳ֹǼơ롣
 *ʲΥ쥸ǡ_interrupt_entryʬ롣
 *
 *쥸
 *r7߼ľSRΥԡ
 *r6ߥϥɥƬɥ쥹(_default_int_handler)
 *r5ֹ
 *r4_interrupt_entry
 *ʳߥϥɥ餬ϿƤȶ̤ν
 */
	.section .vector_entry,"xa"
	.align 2
	.global  _default_int_handler_entry
_default_int_handler_entry:
#ifndef USE_BANKED_REG
	mov.l r5,@-r15				   /*  ɬ׺Ǿ¤Υ쥸򥹥å  */
	mov.l r4,@-r15
#endif /* USE_BANKED_REG */
	mov   r6,r5						/* ֹ */
	movi20 #IIPM_DISALL,r6
	stc   sr,r7						/* SR¸ */
	ldc   r6,sr						/* ߶ػ */
									/* ͭ */
	mov.l _common_routine_default_int_handler,r4
									/* ߥϥɥƬɥ쥹 */
	mov.l _c_routine_default_int_handler,r6
	/*	PCХɥ쥹ʤΤǡٱ䥹åȤˤʤ  */
	jmp   @r4
	 nop

	.align 2
_c_routine_default_int_handler:
	.long _default_int_handler
_common_routine_default_int_handler:
	.long  _interrupt_entry

/*
 *	̤ϿCPU㳰ϥɥ
 *	CPU㳰װr7,r6¸
 *	r6˥٥ֹǼơ롣
 *ʲΥ쥸ǡ_exception_entryʬ롣
 *
 *쥸
 *r7CPU㳰ȯSRΥԡ
 *r6CPU㳰ϥɥƬɥ쥹(_default_exc_handler)
 *r5٥ֹ
 *r4_exception_entry
 *CPU㳰ϥɥ餬ϿƤȶ̤ν
 */
	.section .vector_entry,"xa"
	.align 2
	.global  _default_exc_handler_entry
_default_exc_handler_entry:
		 /*  ɬ׺Ǿ¤Υ쥸򥹥å  */
	mov.l r5,@-r15
	mov.l r4,@-r15
	mov   r6,r5							/* ٥ֹ򥳥ԡ	*/
	movi20 #IIPM_DISALL,r6
	stc   sr,r7							/* SR¸   */
	ldc	  r6,sr							/* ߶ػ */
										/* ͭCPU㳰 */ 
	mov.l _common_routine_exc_default_exc_handler,r4
										/* CPU㳰ϥɥƬɥ쥹 */
	mov.l _c_routine_exc_default_exc_handler,r6
	/*	PCХɥ쥹ʤΤǡٱ䥹åȤˤʤ  */
	jmp	  @r4
	 nop
		/*
		 *	ldc̿ٱ䥹åȤ֤ʤΤϡ
		 *	Ƥ쥸ʤ
		 */

	.align 2
_common_routine_exc_default_exc_handler: /* CPU㳰̤ */
	.long  _exception_entry
_c_routine_exc_default_exc_handler:		/* CPU㳰ϥɥƬɥ쥹 */
	.long  _default_exc_handler


/*
 *	Ԥ
 */
	.text
	.align 2
	.global _sil_dly_nse
_sil_dly_nse:
	mov.l  _sil_dly_tim1, r1
	add    r1, r4
	cmp/pl r4
	bt	   _sil_dly_nse1
	rts/n
_sil_dly_nse1:
	mov.l  _sil_dly_tim2, r1
	add    r1, r4
	cmp/pl r4
	bt	   _sil_dly_nse1
	rts/n

	.align 2
_sil_dly_tim1:
	.long  -SIL_DLY_TIM1
_sil_dly_tim2:
	.long  -SIL_DLY_TIM2
