/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel  
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN  
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  $Id: apsh2ad.h 646 2010-07-01 06:44:52Z mit-kimai $
 */

/*
 *	APSH2AD CPUܡɤΤΥϡɥ񸻤
 */

#ifndef TOPPERS_APSH2AD_H
#define TOPPERS_APSH2AD_H

#include <sil.h>

/*
 *	ץåΥϡɥ񸻤Υ󥯥롼
 */
#include "sh2a_dual_gcc/sh7205.h"

/*
 *	¢եå P = 33.333MHz
 */
#define	PCLOCK			33333333

#ifndef TOPPERS_MACRO_ONLY

/*
 *	ȯĶ¸ν
 */
Inline void
apsh2ad_exit(void)
{
	while(1);
}
#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_APSH2AD_H */
