/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *  $Id: target_support.S 765 2011-01-13 07:18:55Z mit-kimai $
 */

/*
 *	åȰ¸⥸塼 ֥APSH2AD
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

/*
 *	ROMˡDATAΥ0ȡBSSTXTľ֤
 *	뤿ᡤDATAΥ0ˤʤΥߡѿ
 *	ѥκŬˤΤɤᡢ֥ǵҤ
 *	Ƥ롣
 */
	.data
_dummy:
	.long 0x00000000

/*
 *	٥ΥåȰ¸ν
 *
 *	ȥåץ⥸塼ǡν˸ƤӽФ롥
 *	ʲξ֤Ǥʬ롣
 *	r4:ץåINDEX
 *	r5:ơ֥Υǥå=ץåINDEX*4
 */

/*
 *	Υ
 *	
 *	ʲΥ󥹤ǥץå֤Ʊ롣
 *	
 *	CPU0CPU1
 *	åȰ¸target_support.S
 *	ޥե쥸SEM0å
 *	
 *	å		å
 *	FRQCR1ʳFRQCR1Τ
 *	
 *	®¢RAM0ؤΥSYSCRn
 *	
 *	®¢RAM1ؤΥSYSCRn
 *	®¢RAM1ѿcpu1_flag0
 *	®¢RAM1̿ᥳɤ򥳥ԡ
 *	ԡ̿ᥳɤʬ
 *	SEM0Ԥ			SEM0꡼...(1)
 *	
 *	ؤΥ
 *	ʥХơȥν
 *										
 *	ƥ¸start.S
 *	bss/dataν
 *	software_init_hook()θƤӽФ
 *	target_mprc_initialize()θƤӽФ
 *	
 *	cpu1_flag1		cpu1_flag=1ȤʤޤԤ...(2)
 *	
 *	CPU0CPU1Ϥǹή롣
 *	åνʳCPU
 *	ͥ뵯ư
 *	sta_ker()θƤӽФ
 *	
 *	
 *  ¾ץåƱˤϡ
 *  sleep̿ܥץåֳ
 *  ޥե쥸Ȥä¾
 *  RAMؤtest & set̿
 *  ΣĤͤ롣
 *  
 *  ƤѾˤꡢʲ»ब롣
 *  
 *  ߥå
 *  ץåֳߤϻѤǤʤ
 *  
 *  åȿ
 *  FRQCR1쥸CPU1Τǽ
 *  
 *  ®¢RAMؤΥSYSCRnν
 *  ¾ץåϹ®¢ؤΥԲ
 *  ʹ®¢֤줿̿ؤ̿եåԲġ
 *  
 *  ؤΥ
 *  ʥХơȥȥν
 *  ¾ץåϳؤΥԲ
 *  ʳ֤줿̿ؤ̿եåԲġ
 *  
 *  Ǥϡ
 *	CPU0Ԥľ硧ޥե쥸
 *	CPU1Ԥľ硧®¢RAM1Υե饰ѿ
 *  ѤƤ롣
 *	ե饰ѤΤϡ
 *	CPU1CPUХư뤿
 *	target_mprc_initialize()ȴĤʤ
 *	ǥޥե쥸Ƥ롣
 */
	.text
	.align 4
	.globl _hardware_init_hook
_hardware_init_hook:
	tst    r4, r4
	bt     _cpu0
	bra    _cpu1
	nop

    /*******************************
     *  ޥץåξν
     ********************************/
_cpu0:
    /*
     *  ޥե쥸SEMR0νʥå
     *  SEMR0ɤ߽ФȤˤꡢӥå00ʻ񸻻ˤ
     *  롣
     */
	mov.l  _semr0_addr_b, r1
	mov.b  @r1, r2

	/* åȯ(CPG) */
	/* I0=200MHz,B=66.666MHz,P=33.333MHz */
	/*	͡CPU1åI1FRQCR1	*/
	mov.l _frqcr0_addr_h, r1
	movi20 #0x0104, r2
	mov.w r2, @r1

	/*
	 *	RAM0ͭˤ
	 *
	 *	ƥॳȥ쥸ջ
	 *®¢RAMְʳ˥ץ֤롣
	 *SYSCRnؤΥ饤̿ľ˥꡼֤̿롣
	 */
	mov.l _sys_cr1_addr_b, r1	 /*  CPU0®¢RAM0ؤΥͭ  */
	mov   #0xff, r0
	mov.b r0, @r1
	mov.b @r1, r3
							/*  CPU0®¢RAM0ؤΥ饤ͭ  */
	mov.b r0, @(SYSCR2_b - SYSCR1_b, r1)
	mov.b @(SYSCR2_b - SYSCR1_b, r1), r3
							/*  CPU1®¢RAM0ؤΥͭ  */
	mov.b r0, @(SYSCR3_b - SYSCR1_b, r1)
	mov.b @(SYSCR3_b - SYSCR1_b, r1), r3
							/*  CPU1®¢RAM0ؤΥ饤ͭ  */
	mov.b r0, @(SYSCR4_b - SYSCR1_b, r1)
	mov.b @(SYSCR4_b - SYSCR1_b, r1), r0

	/*
	 *	CPU1ȤƱݥ(1)
	 *CPU1®RAM1ʬޤԤġ
	 */
	mov.l  _semr0_addr_b, r1
_wait_cpu1:
	mov.b  @r1, r2
			/*
			 *  SEMR0SEMFӥåȡʥӥå0˰ʳϾ0ɤ߽ФΤǡ
			 *  ĥη̡̥ХȤ0ꤵ롣
			 */
	tst    r2, r2
	bt     _wait_cpu1	/*  SEMR00δ֡Ԥ  */
	
	/*
	 *	Хơȡȥȥԥ󡦥ե󥯥󡦥ȥν
	 */
	sts.l  pr, @-r15	/*  pr¸  */
	mov.l  _target_bsc_pfc_initialize_p, r1
	jsr/n  @r1
	lds.l  @r15+, pr	/*  pr  */

	rts/n

    /************************************
     *  ޥץåǤʤν
     ************************************/
_cpu1:
	/*
	 *	CPU1åI1ʬΨߣ
	 *	FRQCR1ˤϡCPU1ǤʤȥǤʤ
	 */
	mov.l _frqcr1_addr_h, r1
	mov    #00, r2
	mov.w  r2, @r1

	/*
	 *	RAM1ͭˤ
	 *
	 *	ƥॳȥ쥸ջ
	 *®¢RAMְʳ˥ץ֤롣
	 *SYSCRnؤΥ饤̿ľ˥꡼֤̿롣
	 */
	mov.l _sys_cr7_addr_b, r1	 /*  CPU0®¢RAM1ؤΥͭ  */
	mov   #0xff, r0
	mov.b r0, @r1
	mov.b @r1, r3				/*  ߡ꡼  */
							/*  CPU0®¢RAM1ؤΥ饤ͭ  */
	mov.b r0, @(SYSCR8_b - SYSCR7_b, r1)
	mov.b @(SYSCR8_b - SYSCR7_b, r1), r3	/*  ߡ꡼  */
							/*  CPU1®¢RAM1ؤΥͭ  */
	mov.b r0, @(SYSCR9_b - SYSCR7_b, r1)
	mov.b @(SYSCR9_b - SYSCR7_b, r1), r3	/*  ߡ꡼  */
							/*  CPU1®¢RAM1ؤΥ饤ͭ  */
	mov.b r0, @(SYSCR10_b - SYSCR7_b, r1)
	mov.b @(SYSCR10_b - SYSCR7_b, r1), r0	/*  ߡ꡼  */

	/*
	 *	®¢RAM1̿ᥳɤ򥳥ԡ
	 */
	mov.l  _ram1_routine_start_p, r1
	mov.l  _ram1_routine_end_p, r2
	mov.l  _ram1_routine_dst, r3
_copy_ram1:
	mov.l  @r1+, r0
	cmp/hi r1, r2
	mov.l  r0, @r3
	add    #4, r3
	bt	   _copy_ram1
	/*
	 *	®¢RAM1˥ԡ̿ᥳɤʬ
	 */
	mov.l  _ram1_routine_dst, r1
	add    #4, r1		/*  cpu1_flagʬ4Хȥåפ  */
	jmp    @r1
	 nop

	/*
	 *	®¢RAM1֤ѿ̿ᥳ
	 */
	.align 2
_ram1_routine_start:	/*  RAM1˥ԡΰ衧  */

_cpu1_flag:				/*  ƱѤΥե饰ѿcpu1_flag  */
	.long 0x00			/*  ͡0  */

	/*
	 *	CPU0ȤƱݥ(1)
	 *	CPU0ؤ
	 */
	mov.l  _semr0_addr_b, r1
	mov    #SEMR_SEMF_BIT, r2
	mov.b  r2, @r1

	/*
	 *	CPU0ȤƱݥ(2)
	 *	cpu1_flag=1ȤʤޤԤġ
	 */
	mov.l  _cpu1_flag_addr, r1
_wait_cpu0:
	mov.l  @r1, r0
	cmp/eq #1, r0
	bf     _wait_cpu0

	rts/n	/*  start.Sإ꥿  */


	.align 2
_semr0_addr_b:
	.long SEMR0_b
_cpu1_flag_addr:
	.long INNER_RAM1_PAGE0_ADDRESS_START
_ram1_routine_end:	/*  RAM1˥ԡΰ衧ޤ  */


_frqcr0_addr_h:
	.long FRQCR0_h
_frqcr1_addr_h:
	.long FRQCR1_h

_sys_cr1_addr_b:
	.long SYSCR1_b
_sys_cr7_addr_b:
	.long SYSCR7_b
_target_bsc_pfc_initialize_p:
	.long _target_bsc_pfc_initialize


_ram1_routine_start_p:
	.long _ram1_routine_start
_ram1_routine_end_p:
	.long _ram1_routine_end
_ram1_routine_dst:
	.long INNER_RAM1_PAGE0_ADDRESS_START

