/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_syssvc.h 760 2010-12-21 02:30:48Z mit-kimai $
 */

/*
 *  ƥॵӥΥåȰ¸APSH2ADѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "apsh2ad.h"

/*
 *  ץå¸
 */
#include "sh2a_dual_gcc/prc_syssvc.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_TRACE_ENABLE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_TRACE_ENABLE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "APSH2AD(SH7205)"

/*
 *  ưå˥åȰ¸ɽ
 *  ɲä뤿Υޥ
 */
#ifdef PRC_COPYRIGHT
#define TARGET_COPYRIGHT	PRC_COPYRIGHT
#endif /* PRC_COPYRIGHT */

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char_t c);

/*
 *  ꥢݡȿ
 */
#define TNUM_PORT        1        /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP        TNUM_PORT


/*
 *  ܡ졼
 */
#define BPS_SETTING 		38400
#define SCIF0_BPS_SETTING  (((PCLOCK / 32) / BPS_SETTING) - 1)
#define SCIF1_BPS_SETTING  (((PCLOCK / 32) / BPS_SETTING) - 1)

/*
 *  å
 */
/*  åSCK üҤüҡϿ̵  */
#define SCIF0_CKE_SETTING	0x00U
#define SCIF1_CKE_SETTING	0x00U


#define SIO_INIT_DLY		1000000	/* ưԤ(1ӥåʬ) */

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

/*
 *  ƥѤݡȿȼºݤΥݡȿå
 *  
 *  åȥܡɤ˥ꥢݡȤΥͥĤʤᡢ
 *  åȰ¸ΥǥեȤǤϥƥǽ򥰥Х
 *  ǻѤ뤳ȤȤƤ롣
 *  ʥեȥΤTNUM_PORT2ѹС2ݡȻ
 *  Ǥ뤬ϡɥ¦⥳ͥɲäɬפ롣
 *  ХꤹG_SYSLOGޥϡץꥱ
 *  ¦MakefileǹԤץץǤϡG_SYSLOGޥ
 *  ƤʤᡢǥեȤΤޤޥӥɤmake depend
 *  ʲΥ顼åɽ뤬G_SYSLOGޥɲ
 *  뤳ȤˤꡢӥɤǤ褦ˤʤ롣
 *  
 *  G_SYSLOGˡ
 *  ˡ
 *  configureץȤ-sץդƼ¹Ԥ롣
 *  㡧configure -s -T apsh2ad_gcc
 *  ܤϡfmp/doc/user.txt
 *  ֣ե졼󥹥ץȤλȤפ򻲾
 *  ˡ
 *  MakefileѿENABLE_G_SYSLOGtrueꤹ뤳Ȥˤꡤ
 *  ХͭȤʤ롣
 *  ܤϡ桼ޥ˥奢fmp/user.txt
 *  6.1 Makefileѿ
 *  (M) ƥǽΥХλפ򻲾
 */
#if !defined(G_SYSLOG) && (TNUM_PORT < TNUM_PRCID)
#error !defined(G_SYSLOG) && (TNUM_PORT < TNUM_PRCID) : check G_SYSLOG and TNUM_PORT !
#endif /* defined(G_SYSLOG) && (TNUM_PORT == 1) */

#endif /* TOPPERS_TARGET_SYSSVC_H */
