/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_test.h 863 2011-08-04 02:44:49Z mit-kimai $
 */

/*
 *		ƥȥץΥåȰ¸APSH2ADѡ
 */

#ifndef TOPPERS_TARGET_TEST_H
#define TOPPERS_TARGET_TEST_H

#define CPUEXC1				0x10009		/* ɥ쥹顼㳰(CPU0) */
#define CPUEXC2				0x20009		/* ɥ쥹顼㳰(CPU1) */

/*
 *	ɥ쥹顼㳰ȯؿ
 *	
 *	㳰ȯ˥å򤵤PCͤϡֺǸ˼¹Ԥ̿
 *	μ̿Ƭɥ쥹ؤƤ롣
 *	ΡֺǸ˼¹Ԥ̿פȤϼºݤ˥ɥ쥹顼㳰ȯ
 *	̿ǤϤʤ㳰ȯ˥ѥץ饤Ǽ¹ԤƤ
 *	³̿Ǥ롣
 *	㳰ȯ̿᤬ꥢơǡ³̿᤬
 *	˼¹ԥơˤ
 *	
 *	ޤ³̿ʬ̿᤬ޤޤϡ򤹤٤PCͤ
 *	񤭴Ƥ륱롣
 *	
 *	ֺǸ˼¹Ԥ̿פ㳰ȯս꤫鲿̿ΥƤ뤫
 *	쳵ˤϵʤᡢǤnop̿Ƥ롣
 */
Inline void 
toppers_raise_cpu_exception(void)
{
	uint32_t tmp;
	uint32_t adr = 0xfffffec1U;		/*    */
	
	Asm(" mov.l @%1, %0 \n"			/*  ɥ쥹顼㳰ȯ  */
	    " nop           \n"
	    " nop           \n"
	    " nop           \n"			/*  å򤵤륢ɥ쥹  */
	    " nop           " : "=r"(tmp): "r"(adr));
}

#define RAISE_CPU_EXCEPTION	toppers_raise_cpu_exception()

#define LOOP_REF		ULONG_C(500000)	/* ®ٷ¬ѤΥ롼ײ */

/*
 *  ǻѤ륷ꥢݡID
 */
#define TASK_PORTID_PRC1			1
#define TASK_PORTID_PRC2			2

/*
 *  ǽɾѤΥޥ
 */
/*  ǥեȤ򤽤ΤޤѤ롣  */


#endif /* TOPPERS_TARGET_TEST_H */
