/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: prc_ipi.h 816 2011-06-30 02:46:57Z mit-kimai $
 */

/*
 *  ץåֳߥɥ饤СSH2A-DUALѡ
 */

#ifndef TOPPERS_PRC_IPI_H
#define TOPPERS_PRC_IPI_H

/*
 *  make dependcfg1_out.cǥܥirc_reg_tbl
 *  Ĥʤʤ뤿ᡢɲ
 *  ׸ƤϤʤϤ
 */
#include "prc_rename.h"		/*  irc_reg_tblΥ͡  */
#include "prc_config.h"

/*
 *  ֹȳߥϥɥֹ
 */
#define INTNO_IPI_PRC1  (0x10000|IPI08_VECTOR)  /* ֹ */
#define INHNO_IPI_PRC1  INTNO_IPI_PRC1  		/* ߥϥɥֹ */
#define INTPRI_IPI_PRC1 (-8)					/* ͥ */

#define INTNO_IPI_PRC2  (0x20000|IPI08_VECTOR)  /* ֹ */
#define INHNO_IPI_PRC2  INTNO_IPI_PRC2  		/* ߥϥɥֹ */
#define INTPRI_IPI_PRC2 (-8)					/* ͥ */

/*
 *  ץåֳߤȯ
 */
Inline void
target_ipi_raise(uint_t procid)
{
	uint16_t *p_ipcr8_h = irc_reg_tbl[procid - 1].ipcr8_h;
	
	sil_wrh_mem((uint16_t *)p_ipcr8_h, IPCR_CI);
}

/*
 *  ץåֳߤΥꥢ
 */
Inline void
target_ipi_clear(void)
{

}

#endif /* TOPPERS_PRC_IPI_H */
